#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20050813

#define YYEMPTY (-1)
#define yyclearin    (yychar = YYEMPTY)
#define yyerrok      (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

extern int yyparse(void);

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 32 "policy_parse.y"
#include <sys/types.h>
#include <assert.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <sepol/policydb/expand.h>
#include <sepol/policydb/policydb.h>
#include <sepol/policydb/services.h>
#include <sepol/policydb/conditional.h>
#include <sepol/policydb/flask.h>
#include <sepol/policydb/hierarchy.h>
#include "queue.h"
#include "checkpolicy.h"
#include "module_compiler.h"

/* 
 * We need the following so we have a valid error return code in yacc
 * when we have a parse error for a conditional rule.  We can't check 
 * for NULL (ie 0) because that is a potentially valid return.
 */
static avrule_t *conditional_unused_error_code;
#define COND_ERR (avrule_t *)&conditional_unused_error_code

#define TRUE 1
#define FALSE 0

policydb_t *policydbp;
queue_t id_queue = 0;
static unsigned int pass;
char *curfile = 0;
int mlspol = 0;
int handle_unknown = 0;

extern unsigned long policydb_lineno;
extern unsigned long source_lineno;
extern unsigned int policydb_errors;
extern unsigned int policyvers;

extern char yytext[];
extern int yylex(void);
extern int yywarn(char *msg);
extern int yyerror(char *msg);

#define ERRORMSG_LEN 255
static char errormsg[ERRORMSG_LEN + 1] = {0};

static int insert_separator(int push);
static int insert_id(char *id,int push);
static int id_has_dot(char *id);
static int define_class(void);
static int define_initial_sid(void);
static int define_common_perms(void);
static int define_av_perms(int inherits);
static int define_sens(void);
static int define_dominance(void);
static int define_category(void);
static int define_level(void);
static int define_attrib(void);
static int define_typealias(void);
static int define_typeattribute(void);
static int define_type(int alias);
static int define_compute_type(int which);
static int define_te_avtab(int which);
static int define_role_types(void);
static role_datum_t *merge_roles_dom(role_datum_t *r1,role_datum_t *r2);
static role_datum_t *define_role_dom(role_datum_t *r);
static int define_role_trans(void);
static int define_range_trans(int class_specified);
static int define_role_allow(void);
static int define_constraint(constraint_expr_t *expr);
static int define_validatetrans(constraint_expr_t *expr);
static int define_bool(void);
static int define_conditional(cond_expr_t *expr, avrule_t *t_list, avrule_t *f_list );
static cond_expr_t *define_cond_expr(uint32_t expr_type, void *arg1, void* arg2);
static avrule_t *define_cond_pol_list(avrule_t *avlist, avrule_t *stmt);
static avrule_t *define_cond_compute_type(int which);
static avrule_t *define_cond_te_avtab(int which);
static uintptr_t define_cexpr(uint32_t expr_type, uintptr_t arg1, uintptr_t arg2);
static int define_user(void);
static int parse_security_context(context_struct_t *c);
static int define_initial_sid_context(void);
static int define_fs_use(int behavior);
static int define_genfs_context(int has_type);
static int define_fs_context(unsigned int major, unsigned int minor);
static int define_port_context(unsigned int low, unsigned int high);
static int define_netif_context(void);
static int define_ipv4_node_context(unsigned int addr, unsigned int mask);
static int define_ipv6_node_context(void);

typedef int (* require_func_t)();

#line 132 "policy_parse.y"
typedef union {
	unsigned int val;
	uintptr_t valptr;
	void *ptr;
        require_func_t require_func;
} YYSTYPE;
#line 128 "y.tab.c"
#define PATH 257
#define CLONE 258
#define COMMON 259
#define CLASS 260
#define CONSTRAIN 261
#define VALIDATETRANS 262
#define INHERITS 263
#define SID 264
#define ROLE 265
#define ROLES 266
#define TYPEALIAS 267
#define TYPEATTRIBUTE 268
#define TYPE 269
#define TYPES 270
#define ALIAS 271
#define ATTRIBUTE 272
#define BOOL 273
#define IF 274
#define ELSE 275
#define TYPE_TRANSITION 276
#define TYPE_MEMBER 277
#define TYPE_CHANGE 278
#define ROLE_TRANSITION 279
#define RANGE_TRANSITION 280
#define SENSITIVITY 281
#define DOMINANCE 282
#define DOM 283
#define DOMBY 284
#define INCOMP 285
#define CATEGORY 286
#define LEVEL 287
#define RANGE 288
#define MLSCONSTRAIN 289
#define MLSVALIDATETRANS 290
#define USER 291
#define NEVERALLOW 292
#define ALLOW 293
#define AUDITALLOW 294
#define AUDITDENY 295
#define DONTAUDIT 296
#define SOURCE 297
#define TARGET 298
#define SAMEUSER 299
#define FSCON 300
#define PORTCON 301
#define NETIFCON 302
#define NODECON 303
#define FSUSEXATTR 304
#define FSUSETASK 305
#define FSUSETRANS 306
#define GENFSCON 307
#define U1 308
#define U2 309
#define U3 310
#define R1 311
#define R2 312
#define R3 313
#define T1 314
#define T2 315
#define T3 316
#define L1 317
#define L2 318
#define H1 319
#define H2 320
#define NOT 321
#define AND 322
#define OR 323
#define XOR 324
#define CTRUE 325
#define CFALSE 326
#define IDENTIFIER 327
#define NUMBER 328
#define EQUALS 329
#define NOTEQUAL 330
#define IPV6_ADDR 331
#define MODULE 332
#define VERSION_IDENTIFIER 333
#define REQUIRE 334
#define OPTIONAL 335
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   24,   28,   33,   21,   23,   23,   38,   25,
   25,   40,   26,   41,   41,   43,   43,   44,   42,   42,
   46,   46,   46,   27,   27,   47,   48,   48,   53,   53,
   54,   49,   49,   50,   50,   56,   56,   57,   57,   51,
   51,   58,   58,   52,   52,   60,   60,   61,   62,   29,
   29,   63,   63,   63,   63,   63,   65,   65,   65,   65,
   64,   64,   64,   64,   64,   64,   64,   64,   72,   73,
   73,   74,   75,   80,   80,   76,   81,   81,   66,    4,
    4,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    3,    3,   11,   11,   11,    9,    9,    9,   10,   10,
   10,   10,    5,    6,    7,    8,   77,   77,   77,   78,
   78,   79,   79,   79,   79,   79,   84,   85,   86,   87,
   88,   68,   68,   69,   70,   71,   13,   13,   12,   12,
   31,   31,   90,   90,   91,   91,   92,   93,   14,   14,
   14,   14,   14,   15,   15,   15,   95,   15,   96,   15,
   97,   15,   98,   15,   99,   15,  100,   15,  101,   15,
  102,   15,  103,   15,   15,  104,   15,  105,   15,   15,
  106,   15,  107,   15,   15,   15,   15,   15,   15,   15,
   16,   16,   17,   17,   17,   17,   30,   30,  108,  109,
  109,   32,   32,  111,   34,   34,  113,  113,  114,   37,
  115,  115,  118,  118,  119,  119,  116,  116,  120,  120,
  121,  117,  117,  122,  122,  123,  123,   35,   35,  125,
  125,  126,  126,  126,   36,   36,  127,  127,  128,  130,
  128,  128,   18,  112,  131,  131,   83,   83,  110,  110,
   59,   59,  132,  133,   55,   55,   55,   55,   55,  135,
   55,  136,  137,   94,   94,   94,   94,   94,  138,  138,
   89,   45,   45,  134,  139,  139,  140,  141,  140,  140,
   39,  129,   19,  124,   22,  142,  144,  143,  145,  145,
  147,  147,  147,  147,  147,  147,   82,  148,  148,  149,
  149,  150,   20,   20,   20,   20,   20,   20,   20,  151,
  151,  154,   67,  153,  153,  152,  155,  146,  146,
};
short yylen[] = {                                         2,
    1,    1,    0,    0,    0,   15,    1,    2,    2,    1,
    2,    2,    2,    1,    0,    1,    2,    5,    1,    2,
    5,    4,    7,    1,    0,    5,    1,    2,    4,    3,
    2,    2,    4,    1,    0,    1,    2,    4,    3,    1,
    2,    5,    3,    1,    2,    1,    1,    5,    4,    1,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    3,    5,
    4,    4,    4,    2,    0,    4,    1,    1,    6,    4,
    0,    3,    2,    3,    3,    3,    3,    3,    1,    1,
    2,    0,    1,    1,    1,    7,    7,    7,    1,    1,
    1,    1,    7,    7,    7,    7,    7,    7,    7,    5,
    7,    1,    1,    1,    1,    1,    7,    7,    7,    7,
    7,    5,    3,    4,    5,    4,    1,    2,    3,    5,
    1,    0,    1,    2,    1,    1,    5,    4,    3,    2,
    3,    3,    1,    3,    3,    3,    0,    4,    0,    4,
    0,    4,    0,    4,    0,    4,    0,    4,    0,    4,
    0,    4,    0,    4,    1,    0,    4,    0,    4,    2,
    0,    4,    0,    4,    3,    3,    3,    3,    3,    3,
    1,    1,    1,    1,    1,    1,    1,    2,    6,    4,
    0,    1,    2,    3,    1,    0,    1,    2,    5,    3,
    1,    0,    1,    2,    4,    6,    1,    0,    1,    2,
    4,    1,    0,    1,    2,    4,    4,    1,    0,    1,
    2,    4,    4,    4,    1,    0,    1,    2,    6,    0,
    7,    4,    7,    6,    2,    0,    3,    1,    3,    1,
    1,    3,    1,    1,    1,    1,    1,    2,    2,    0,
    4,    1,    1,    1,    3,    1,    2,    4,    1,    2,
    1,    1,    2,    3,    1,    2,    1,    0,    3,    1,
    1,    1,    1,    1,    2,    4,    1,    2,    2,    1,
    1,    1,    1,    1,    1,    1,    4,    2,    1,    2,
    3,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    3,    0,    6,    4,    0,    1,    1,    2,    0,
};
short yydefred[] = {                                      0,
    0,    0,    1,    2,    0,    0,  271,    0,    0,    0,
    7,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  306,  286,  282,  281,  283,  285,   57,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,  284,  112,
  113,  114,  115,  116,  275,    0,  280,    0,  277,    0,
    9,    0,    0,    8,   10,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   89,   90,    0,  243,  244,    0,
    0,    0,  247,  246,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  278,  279,    0,
  276,   12,    0,    4,   11,    0,    0,   16,    0,  123,
    0,    0,  241,    0,    0,    0,    0,   69,   77,   78,
    0,    0,    0,    0,    0,    0,    0,    0,   92,  268,
  267,  270,    0,  265,  250,    0,  248,  249,    0,    0,
    0,    0,    0,  127,    0,    0,    0,    0,    0,    0,
    0,  293,  294,  295,  297,  298,  299,  296,    0,    0,
  289,    0,    0,  308,    0,    0,    0,    0,    0,   19,
   17,    0,   31,   72,   73,    0,    0,    0,   71,   76,
   82,    0,    0,    0,   87,   88,    0,    0,  264,  266,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  261,
    0,  124,  128,    0,  126,    0,    0,    0,    0,    0,
  300,    0,  287,  288,  290,    0,  302,    0,    0,    0,
   24,    0,   27,    0,   20,  122,  242,   70,    0,    0,
    0,    0,    0,    0,    0,    0,   99,  100,  101,  102,
   93,   94,   91,   95,  269,  251,    0,    0,    0,  125,
    0,    0,  110,    0,    0,  129,    0,    0,    0,    0,
    0,  292,  291,    0,    0,    0,  262,    0,    0,   56,
    0,   50,   52,   53,   54,   55,    0,    0,   28,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   79,
    0,    0,    0,    0,    0,  237,    0,    0,    0,    0,
    0,    0,  301,    0,    0,  307,  303,    0,   18,  263,
   30,    0,    0,   51,  187,    0,   32,    0,    0,    0,
   36,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   92,  107,  108,  109,  111,  130,  121,  117,  118,  119,
  120,    0,  189,    0,   29,    0,    0,    5,    0,  133,
  135,  136,  188,    0,    0,    0,    0,   40,   37,    0,
   21,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  134,   33,   39,    0,    0,    0,
    0,    0,   41,   44,   46,   47,    0,    0,    0,    0,
    0,    0,    0,    0,   80,  190,  304,    0,    0,    0,
    0,  165,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  143,    0,    0,
  192,   38,   43,    0,    0,    0,   45,   23,    0,    0,
    0,    0,    0,    0,    0,    0,  184,  185,  186,  181,
  182,  183,  170,  166,  171,  168,  173,    0,  149,  151,
    0,    0,  155,  157,    0,  161,  163,    0,    0,    0,
  140,    0,    0,    0,  138,    0,    0,    0,  193,    0,
  197,    0,    0,    0,   96,   97,   98,  103,  104,  105,
  106,  137,    0,    0,    0,    0,  144,    0,    0,    0,
    0,  145,    0,    0,  146,    0,    0,    0,  175,  179,
  176,  180,  177,  178,  139,  141,    0,    0,  194,  273,
    0,    0,    0,    0,    0,    0,  220,  198,   42,    0,
   49,    0,  254,  167,  252,  253,    0,  256,  172,  169,
  174,  148,  150,  152,  154,  156,  158,  160,  162,  164,
    0,    0,    0,    0,    0,    0,    0,    0,  227,  221,
   48,  259,    0,    0,  257,    0,    0,    0,    0,    0,
    0,    0,    6,    0,    0,  203,  228,  255,  260,    0,
    0,  199,  222,  223,  224,  272,    0,    0,    0,    0,
    0,  209,  204,  258,    0,    0,  232,    0,    0,    0,
  200,    0,  214,  210,    0,  234,  230,    0,    0,  205,
    0,  274,    0,    0,    0,  215,  235,    0,  229,    0,
  211,    0,    0,    0,  231,  206,  216,    0,  217,    0,
    0,    0,  233,
};
short yydgoto[] = {                                       2,
   74,   75,  187,  290,  237,  238,  239,  240,  241,  242,
  243,  144,  145,  417,  418,  442,  443,  603,  604,  159,
    3,    4,   10,    5,   63,  104,  220,  167,  271,  313,
  348,  420,  374,  468,  515,  547,  563,   11,   80,   65,
  106,  169,  107,  108,  268,  170,  221,  222,  278,  319,
  357,  382,  223,  112,   81,  320,  321,  358,  114,  384,
  385,  386,  272,   33,   34,   35,   36,   37,   38,   39,
   40,   41,   42,   43,   44,   45,   46,   47,   48,  117,
  121,   49,  198,   50,   51,   52,   53,   54,  523,  349,
  350,  351,  352,  524,  488,  489,  490,  491,  493,  494,
  496,  497,  498,  483,  485,  484,  486,   97,  305,  199,
  421,  509,  470,  471,  564,  580,  591,  565,  566,  581,
  582,  592,  593,  605,  516,  517,  548,  549,  577,  608,
  596,   82,   83,   84,  191,  527,  528,  553,  133,  134,
  188,    6,   55,   60,   56,   98,   57,  160,  161,  162,
  212,   58,  307,  266,  308,
};
short yysindex[] = {                                   -275,
 -250,    0,    0,    0, -194,  645,    0, -239, -250, -186,
    0, -250, -250, -250, -250, -250, -250,  -34,   50,   50,
   50,   50,   50,  -19,   50,   50,   50,   50,   50,  -11,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  564,    0,   -4,    0,   89,
    0, -250, -128,    0,    0,  -32, -109, -250,  -22,  127,
 -170,  -34,  -34,  -90,    0,    0,   72,    0,    0,  133,
   50,  -98,    0,    0,   50,   50,   50,   50,  -57,   50,
   50,   50,   50,   50,  286, -250,  -78,    0,    0,  645,
    0,    0, -250,    0,    0,  -45,  -17,    0,   50,    0,
   50,  162,    0,   11, -250,  149,  165,    0,    0,    0,
  178, -158,  -38,  -34,  -34,  -34,  -34,  -34,    0,    0,
    0,    0,   41,    0,    0,  199,    0,    0,  207,  217,
 -250,  -53,  -46,    0,  -91,  240,  143,  300,  321,  324,
 -250,    0,    0,    0,    0,    0,    0,    0, -250,  -81,
    0,  325,  168,    0,  323,  334,  188, -250,  -45,    0,
    0,  413,    0,    0,    0, -250,  455,  449,    0,    0,
    0, -158, -161, -214,    0,    0,  297, -250,    0,    0,
 -250,   50,   50,   50,  450,   50,  452,  456,  469,    0,
  -18,    0,    0,   50,    0,   50,   50,   50,   50,   50,
    0,   74,    0,    0,    0,   50,    0, -250, -250,  766,
    0,  -54,    0,  -67,    0,    0,    0,    0,   50,   50,
   50,   50,   50,   50,   50,  243,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -250, -250, -250,    0,
 -250, -250,    0, -250,  -57,    0,   50,   50,   50,   50,
   50,    0,    0, -250,  233,  256,    0,  -97,  -36,    0,
  690,    0,    0,    0,    0,    0,  -84,  246,    0, -250,
 -250,   50,   50,   50,   50,   50,   50,   50,  415,    0,
  474,  477,  480,  488,  455,    0,  -66,  489,  491,  494,
  498,  501,    0, -250,  503,    0,    0,  440,    0,    0,
    0,  505, -182,    0,    0, -250,    0, -250,  278,  246,
    0,  443,  -96,  510,  511,  513,  521,  522,  523,  524,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  295,    0,  645,    0,   50,   50,    0,    9,    0,
    0,    0,    0,  -82,  -35, -250,  -21,    0,    0, -250,
    0,   50,   50,   50,   50,   50,   50,   50,  356, -250,
  459,   50,  497,  322,    0,    0,    0,  530,  219,   50,
   50,    6,    0,    0,    0,    0,  -73, -250, -250, -250,
   50,   50,   50,   50,    0,    0,    0,  497,  205, -123,
  -43,    0,  -41,  -41,  -41,  205,  -41,  -41,  -41,  -41,
  -41,  205,  205,  205,  497,  497,  -50,    0, -250, -217,
    0,    0,    0, -250,   50,  497,    0,    0,  536,  537,
  540,  542,  546,  549,  551,  -40,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  303,    0,    0,
    0,  309,    0,    0,  307,    0,    0,  174,  304, -236,
    0,  157,  497,  497,    0, -250,  287,  201,    0,  327,
    0,   78,  497,  160,    0,    0,    0,    0,    0,    0,
    0,    0,   54,   54,   54,   54,    0,   54,   54,   54,
   54,    0,   54,   54,    0,   54,   54,   54,    0,    0,
    0,    0,    0,    0,    0,    0,  306,  567,    0,    0,
  287, -250, -250, -250,  328,  201,    0,    0,    0,  164,
    0,  -46,    0,    0,    0,    0,  -83,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -250, -250, -250, -250, -250, -250,  329,  328,    0,    0,
    0,    0,  -72,  -46,    0,  571, -250,  577,  578,  579,
  389, -250,    0,  345,  329,    0,    0,    0,    0,  -71,
 -250,    0,    0,    0,    0,    0,  136,  287, -250,  350,
  345,    0,    0,    0,  590,  140,    0,  144, -250, -263,
    0,  350,    0,    0, -250,    0,    0, -250,  287,    0,
 -250,    0,  287,  608,  326,    0,    0, -250,    0, -250,
    0, -250,  287, -250,    0,    0,    0,  609,    0,  287,
  610,  287,    0,
};
short yyrindex[] = {                                    398,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   35,    0,    0,    0,    0,
    0,    0,  399,    0,    0,    0,    0,    0,  602,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  426,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   35,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  402,    0,    0,    0,
    0,    0,    0,    0,    0,  602,    0,    0,    0,    0,
    0,   97,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  803,    0,  722,    0,
    0,    0,    0,    0,    0,    0,  604,    0,    0,    0,
    0,  102,   93,  129,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   30,    0,   38,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   32,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  605,  182,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  379,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   90,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  408,    0,    0,    0,    0,    0,    0,  386,
    0,  601,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  414,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  841,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   69,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   86,    0,    0,
   71,    0,    0,    0,   88,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   49,    0,  139,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  106,    0,    0,    0,
    0,    0,    0,    0,   18,  107,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   58,   46,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   10,   60,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  683,
   26,    0,    0,    0,  100,    0,    0,    0,    0,    0,
    0,  699,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,
};
short yygindex[] = {                                      0,
  134,    0,  370,    0,    0,    0,    0,    0,    0,    0,
    0, -114,  447, -353,    0,  119, -261,  103,   87,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  693,   -1,  642,
    0,    0,    0,  603, -231,  539,    0,    0,    0,    0,
    0,    0,  490,  -65,  410,    0,  391,  357, -108,  333,
    0,    0,  445, -184, -183, -178, -172,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  606,
    0, -166, -249,    0,    0,    0,    0,    0, -142,    0,
  368,    0,    0,  713,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -207,    0, -203,
  298,  582,    0,  249,    0,    0,    0,    0,  155,    0,
  145,    0,  135,  116,    0,  212,    0,  181,    0,    0,
    0,  191,  657,   21,    0,    0,    0,  176,    0,  598,
    0,    0,  -80,    0,    0,  635,  677,    0,  586,    0,
    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 1211
short yytable[] = {                                       8,
  201,  294,  181,  116,  196,   73,  177,   61,  465,  208,
   66,   67,   68,   69,   70,   71,   76,  226,  482,  165,
  244,  115,  311,  377,   77,  207,  110,  309,  361,  240,
  203,   81,  129,  202,  309,  273,  274,  238,  316,  554,
  256,  275,  376,  213,  436,  225,  419,  276,  219,  323,
  296,  428,  568,  584,  176,  281,    1,  202,  336,  201,
  102,  461,  462,  315,  510,    9,  113,  602,  196,  175,
   76,   76,  474,    9,  240,  131,    7,   62,  346,  347,
  137,  503,  467,  504,  354,  130,  273,  274,  240,  239,
   81,   79,  275,   59,  163,   79,  238,  132,  276,  236,
  342,  166,  138,   89,  255,  353,  218,  124,   96,  506,
  507,   95,  153,  113,  127,  128,  130,  264,  100,  520,
  396,  176,   76,   76,   76,   76,   76,  147,  387,  159,
  103,  131,  263,   85,  239,   62,  519,   83,  195,  195,
  197,  444,   84,  295,  452,  445,  142,  101,  239,  210,
  458,  459,  460,  132,  119,  120,   81,  211,  236,  309,
  124,  111,  126,   77,  142,  189,  224,  127,  128,   86,
  127,  128,   77,  143,  227,   78,  522,  135,  151,   78,
  586,  305,  203,  152,  597,  118,  245,  153,  599,  246,
  154,  155,  115,  153,   77,  280,  153,  505,  143,  156,
  206,  205,  244,  312,  157,  122,  123,  143,  147,  158,
  159,  147,   96,  159,  168,   85,  267,  269,  521,   83,
  174,  446,  551,  179,   84,  447,  219,  277,    7,    7,
    7,  124,  125,  126,  111,  111,  180,  109,  127,  128,
  305,  103,    7,  200,    7,  291,  292,  293,  111,  197,
  113,   86,  197,    7,  200,  200,  192,  182,  183,  184,
  185,  186,  303,  371,  193,  356,  310,  380,  381,  346,
  347,  463,  464,    7,  194,  317,  424,  423,  322,  267,
  200,  463,  464,  124,  125,  126,   72,  440,  441,  378,
  127,  128,    7,  240,  380,  381,   81,  204,   81,   81,
   81,  238,  197,   81,   81,   81,  305,   81,   81,   81,
   81,   81,  208,   81,  267,  472,  355,  240,  226,  226,
  226,  310,   81,   81,   81,   81,   81,   81,  207,  240,
  240,  240,  240,  240,  240,  240,  240,  238,  238,  238,
  238,  238,  238,  238,  238,  607,  225,  225,  225,  219,
  219,  219,  310,  239,  379,  219,  240,  207,  267,  202,
  202,  201,  201,  236,  238,   81,   81,    7,  197,  196,
  196,  196,  196,  196,  196,  196,    7,  239,  208,  552,
  200,  209,  183,  215,  555,  310,  429,  430,  431,  239,
  239,  239,  239,  239,  239,  239,  239,  153,    7,  236,
  236,  236,  236,  236,  236,  236,  236,  218,  218,  218,
  569,  552,  147,  218,  159,   85,  239,  466,   83,   83,
   83,  236,  113,   84,   84,   84,  236,  569,  142,   85,
   86,   87,   88,  216,   90,   91,   92,   93,   94,  195,
  195,  195,  195,  195,  195,  195,  305,  217,  305,  305,
  305,   86,   86,  305,  305,  305,  218,  305,  305,  305,
  305,  305,    7,  305,  508,  245,    7,  245,  219,  245,
    7,  226,  305,  305,  305,  305,  305,  305,  463,  464,
  395,  463,  464,  245,  245,  463,  464,  437,  438,  439,
  136,  499,  500,  501,  139,  140,  141,  142,  176,  146,
  147,  148,  149,  150,  512,  513,  514,  228,  250,  252,
  543,  544,  545,  254,  253,  305,  305,  289,  172,  304,
  173,  448,  449,  450,  451,  453,  454,  455,  456,  457,
  306,  318,  332,  440,  441,  333,  416,  331,  334,  556,
  508,  508,  508,  508,  561,  151,  335,  337,  245,  338,
  152,  245,  339,  511,  153,  508,  340,  154,  155,  341,
  578,  343,  344,  345,  356,  360,  156,  362,  363,  585,
  364,  157,  229,  230,  231,  508,  158,  589,  365,  366,
  367,  368,  370,  397,  598,  419,  508,  508,  422,  232,
  233,  234,  235,  197,  475,  476,  508,  542,  477,  508,
  478,  247,  248,  249,  479,  251,  508,  480,  508,  481,
  508,  487,  508,  257,  510,  258,  259,  260,  261,  262,
  492,  495,   32,  502,  541,  265,  467,  463,  571,  562,
   30,  229,  230,  231,  546,  573,  574,  575,  282,  283,
  284,  285,  286,  287,  288,  576,  579,  595,  232,  233,
  234,  235,  590,  613,  620,  622,  602,    3,   15,   22,
   75,   14,   74,  191,  588,   35,  298,  299,  300,  301,
  302,  132,   34,  525,  525,  525,  525,  131,  525,  525,
  525,  525,  213,  525,  525,  610,  525,  525,  525,   30,
  245,  324,  325,  326,  327,  328,  329,  330,  212,  618,
  369,  297,   64,   32,  105,  612,  621,  225,  623,  171,
  359,  279,  245,  383,  427,  314,  375,  469,  518,  583,
  614,  178,  245,  245,  245,  594,  606,  550,  567,  570,
  190,  164,   99,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  214,  245,    0,  270,    0,
    0,    0,  245,    0,    0,  372,  373,    0,    0,    0,
    0,  399,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  388,  389,  390,  391,  392,  393,  394,    0,    0,
   13,  398,    0,    0,    0,    0,    0,    0,    0,  425,
  426,    0,    0,  400,  401,  402,    0,    0,    0,    0,
  432,  433,  434,  435,  403,  404,  405,  406,  407,  408,
  409,  410,  411,  412,  413,  414,    0,  415,    0,    0,
    0,    0,    0,    0,  270,    0,    0,    0,   12,    0,
   13,   14,   15,    0,  473,   16,   17,   18,    0,   19,
   20,   21,   22,   23,    0,   24,    0,    0,    0,    0,
    0,    0,    0,    0,   96,   25,   26,   27,   28,   29,
   22,   25,    0,    0,    0,   22,    0,   22,   22,   22,
    0,    0,   22,   22,   22,    0,   22,   22,   22,   22,
   22,   22,   22,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   22,   22,   22,   22,   22,   30,   31,   26,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   12,
    0,   13,   14,   15,    0,    0,   16,   17,   18,    0,
   19,   20,   21,   22,   23,    0,   24,    0,    0,    0,
    0,    0,    0,    0,    0,   22,   25,   26,   27,   28,
   29,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   12,    0,   13,   14,   15,    0,
    0,   16,   17,   18,    0,   19,   20,   21,   22,   23,
    0,   24,    0,    0,    0,    0,    0,    0,   30,   31,
   96,   25,   26,   27,   28,   29,   13,    0,   13,   13,
   13,    0,    0,   13,   13,   13,    0,   13,   13,   13,
   13,   13,   13,   13,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   13,   13,   13,   13,   13,    0,    0,
    0,    0,    0,    0,   31,    0,    0,    0,    0,    0,
   12,    0,   13,   14,   15,    0,    0,   16,   17,   18,
    0,   19,   20,   21,   22,   23,    0,   24,    0,    0,
    0,    0,    0,    0,    0,    0,   13,   25,   26,   27,
   28,   29,    0,    0,    0,    0,    0,   25,    0,   25,
   25,   25,    0,    0,   25,   25,   25,    0,   25,   25,
   25,   25,   25,    0,   25,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   25,   25,   25,   25,   25,    0,
   31,    0,    0,    0,    0,   26,    0,   26,   26,   26,
    0,    0,   26,   26,   26,    0,   26,   26,   26,   26,
   26,    0,   26,  557,  558,  559,  560,    0,    0,    0,
    0,    0,   26,   26,   26,   26,   26,   25,  572,  526,
  526,  526,  526,    0,  526,  526,  526,  526,    0,  526,
  526,    0,  526,  526,  526,    0,    0,    0,  587,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  600,
  601,    0,    0,    0,    0,   26,    0,    0,    0,  609,
    0,    0,  611,    0,    0,    0,    0,    0,    0,  615,
    0,  616,    0,  617,    0,  619,  529,  530,  531,    0,
  532,  533,  534,  535,    0,  536,  537,    0,  538,  539,
  540,
};
short yycheck[] = {                                       1,
  143,  251,   41,   69,   58,   40,  115,    9,   59,    0,
   12,   13,   14,   15,   16,   17,   18,    0,   59,  100,
  187,   44,   59,   59,  123,    0,   59,  125,  125,    0,
  145,    0,  123,  125,    0,  220,  220,    0,  123,  123,
   59,  220,  125,  125,  398,    0,  264,  220,    0,  281,
  254,  125,  125,  125,   44,  123,  332,    0,  125,    0,
   62,  415,  416,  271,  328,  260,   68,  331,    0,   59,
   72,   73,  426,  260,   45,   77,  327,  264,  261,  262,
   82,  318,  300,  320,  316,   45,  271,  271,   59,    0,
   59,   42,  271,  333,   96,   42,   59,   77,  271,    0,
  304,  103,   82,  123,  123,  313,    0,  322,  291,  463,
  464,  123,   42,  115,  329,  330,   45,   44,  123,  473,
  370,   44,  124,  125,  126,  127,  128,   42,  360,   42,
  259,  133,   59,   41,   45,  264,   59,   41,    0,  141,
  142,  265,   41,  252,  406,  269,   41,   59,   59,  151,
  412,  413,  414,  133,  325,  326,  125,  159,   59,  125,
  322,  271,  324,  123,   59,  125,  168,  329,  330,   41,
  329,  330,  123,  265,  176,  126,  123,   45,  260,  126,
   45,    0,  297,  265,   45,   59,  188,  269,   45,  191,
  272,  273,   44,  123,  123,  263,  126,   41,  265,  281,
   58,   59,  369,  269,  286,   72,   73,  265,  123,  291,
  123,  126,  291,  126,  260,  123,  218,  219,   59,  123,
   59,  265,   59,   59,  123,  269,  281,  282,  327,  327,
  327,  322,  323,  324,  271,  271,   59,  270,  329,  330,
   59,  259,  327,  327,  327,  247,  248,  249,  271,  251,
  252,  123,  254,  327,  327,  327,   58,  124,  125,  126,
  127,  128,  264,  344,   58,  287,  268,  289,  290,  261,
  262,  322,  323,  327,   58,  277,   58,   59,  280,  281,
  327,  322,  323,  322,  323,  324,  321,  329,  330,  355,
  329,  330,  327,  264,  289,  290,  265,   58,  267,  268,
  269,  264,  304,  272,  273,  274,  125,  276,  277,  278,
  279,  280,  303,  282,  316,  424,  318,  288,  301,  302,
  303,  323,  291,  292,  293,  294,  295,  296,  303,  300,
  301,  302,  303,  304,  305,  306,  307,  300,  301,  302,
  303,  304,  305,  306,  307,  595,  301,  302,  303,  301,
  302,  303,  354,  264,  356,  307,  327,   58,  360,  302,
  303,  302,  303,  264,  327,  334,  335,  327,  370,  301,
  302,  303,  304,  305,  306,  307,  327,  288,   58,  522,
  327,   58,  312,   59,  527,  387,  388,  389,  390,  300,
  301,  302,  303,  304,  305,  306,  307,  327,  327,  300,
  301,  302,  303,  304,  305,  306,  307,  301,  302,  303,
  553,  554,  327,  307,  327,  323,  327,  419,  322,  323,
  324,  125,  424,  322,  323,  324,  327,  570,  323,   20,
   21,   22,   23,  266,   25,   26,   27,   28,   29,  301,
  302,  303,  304,  305,  306,  307,  265,  125,  267,  268,
  269,  323,  324,  272,  273,  274,  123,  276,  277,  278,
  279,  280,  327,  282,  466,   40,  327,   42,  281,   44,
  327,   59,  291,  292,  293,  294,  295,  296,  322,  323,
  125,  322,  323,   58,   59,  322,  323,  283,  284,  285,
   81,  318,  319,  320,   85,   86,   87,   88,   44,   90,
   91,   92,   93,   94,  304,  305,  306,   59,   59,   58,
  512,  513,  514,   45,   59,  334,  335,  275,  109,  287,
  111,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  275,  286,   59,  329,  330,   59,   40,  123,   59,  541,
  542,  543,  544,  545,  546,  260,   59,   59,  123,   59,
  265,  126,   59,  467,  269,  557,   59,  272,  273,   59,
  562,   59,  123,   59,  287,  123,  281,   58,   58,  571,
   58,  286,  276,  277,  278,  577,  291,  579,   58,   58,
   58,   58,  288,  125,  586,  264,  588,  589,   59,  293,
  294,  295,  296,  595,   59,   59,  598,  511,   59,  601,
   59,  192,  193,  194,   59,  196,  608,   59,  610,   59,
  612,  309,  614,  204,  328,  206,  207,  208,  209,  210,
  312,  315,   59,  320,   58,  216,  300,  322,   58,  301,
  334,  276,  277,  278,  307,   59,   59,   59,  229,  230,
  231,  232,  233,  234,  235,  257,  302,   58,  293,  294,
  295,  296,  303,   46,   46,   46,  331,  260,  260,   59,
   59,  260,   59,   59,  578,  287,  257,  258,  259,  260,
  261,  264,  287,  483,  484,  485,  486,  264,  488,  489,
  490,  491,    0,  493,  494,  599,  496,  497,  498,  334,
  265,  282,  283,  284,  285,  286,  287,  288,    0,  613,
  331,  255,   10,   59,   63,  603,  620,  169,  622,  107,
  320,  222,  287,  357,  382,  271,  349,  420,  470,  565,
  605,  116,  297,  298,  299,  581,  592,  516,  548,  554,
  133,   97,   56,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,  319,  160,  321,   -1,   59,   -1,
   -1,   -1,  327,   -1,   -1,  346,  347,   -1,   -1,   -1,
   -1,  265,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  362,  363,  364,  365,  366,  367,  368,   -1,   -1,
   59,  372,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  380,
  381,   -1,   -1,  297,  298,  299,   -1,   -1,   -1,   -1,
  391,  392,  393,  394,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,   -1,  321,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,  265,   -1,
  267,  268,  269,   -1,  425,  272,  273,  274,   -1,  276,
  277,  278,  279,  280,   -1,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  291,  292,  293,  294,  295,  296,
  260,   59,   -1,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,  272,  273,  274,   -1,  276,  277,  278,  279,
  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  292,  293,  294,  295,  296,  334,  335,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  265,
   -1,  267,  268,  269,   -1,   -1,  272,  273,  274,   -1,
  276,  277,  278,  279,  280,   -1,  282,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,  292,  293,  294,  295,
  296,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,   -1,
   -1,  272,  273,  274,   -1,  276,  277,  278,  279,  280,
   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,  334,  335,
  291,  292,  293,  294,  295,  296,  265,   -1,  267,  268,
  269,   -1,   -1,  272,  273,  274,   -1,  276,  277,  278,
  279,  280,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  292,  293,  294,  295,  296,   -1,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,  272,  273,  274,
   -1,  276,  277,  278,  279,  280,   -1,  282,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  292,  293,  294,
  295,  296,   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,
  268,  269,   -1,   -1,  272,  273,  274,   -1,  276,  277,
  278,  279,  280,   -1,  282,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  292,  293,  294,  295,  296,   -1,
  335,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,  272,  273,  274,   -1,  276,  277,  278,  279,
  280,   -1,  282,  542,  543,  544,  545,   -1,   -1,   -1,
   -1,   -1,  292,  293,  294,  295,  296,  335,  557,  483,
  484,  485,  486,   -1,  488,  489,  490,  491,   -1,  493,
  494,   -1,  496,  497,  498,   -1,   -1,   -1,  577,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  588,
  589,   -1,   -1,   -1,   -1,  335,   -1,   -1,   -1,  598,
   -1,   -1,  601,   -1,   -1,   -1,   -1,   -1,   -1,  608,
   -1,  610,   -1,  612,   -1,  614,  484,  485,  486,   -1,
  488,  489,  490,  491,   -1,  493,  494,   -1,  496,  497,
  498,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 335
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'",0,"','","'-'","'.'",0,0,0,0,0,0,0,0,0,0,0,"':'",
"';'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'","'~'",0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"PATH","CLONE","COMMON","CLASS","CONSTRAIN","VALIDATETRANS",
"INHERITS","SID","ROLE","ROLES","TYPEALIAS","TYPEATTRIBUTE","TYPE","TYPES",
"ALIAS","ATTRIBUTE","BOOL","IF","ELSE","TYPE_TRANSITION","TYPE_MEMBER",
"TYPE_CHANGE","ROLE_TRANSITION","RANGE_TRANSITION","SENSITIVITY","DOMINANCE",
"DOM","DOMBY","INCOMP","CATEGORY","LEVEL","RANGE","MLSCONSTRAIN",
"MLSVALIDATETRANS","USER","NEVERALLOW","ALLOW","AUDITALLOW","AUDITDENY",
"DONTAUDIT","SOURCE","TARGET","SAMEUSER","FSCON","PORTCON","NETIFCON","NODECON",
"FSUSEXATTR","FSUSETASK","FSUSETRANS","GENFSCON","U1","U2","U3","R1","R2","R3",
"T1","T2","T3","L1","L2","H1","H2","NOT","AND","OR","XOR","CTRUE","CFALSE",
"IDENTIFIER","NUMBER","EQUALS","NOTEQUAL","IPV6_ADDR","MODULE",
"VERSION_IDENTIFIER","REQUIRE","OPTIONAL",
};
char *yyrule[] = {
"$accept : policy",
"policy : base_policy",
"policy : module_policy",
"$$1 :",
"$$2 :",
"$$3 :",
"base_policy : $$1 classes initial_sids access_vectors $$2 opt_mls te_rbac users opt_constraints $$3 initial_sid_contexts opt_fs_contexts opt_fs_uses opt_genfs_contexts net_contexts",
"classes : class_def",
"classes : classes class_def",
"class_def : CLASS identifier",
"initial_sids : initial_sid_def",
"initial_sids : initial_sids initial_sid_def",
"initial_sid_def : SID identifier",
"access_vectors : opt_common_perms av_perms",
"opt_common_perms : common_perms",
"opt_common_perms :",
"common_perms : common_perms_def",
"common_perms : common_perms common_perms_def",
"common_perms_def : COMMON identifier '{' identifier_list '}'",
"av_perms : av_perms_def",
"av_perms : av_perms av_perms_def",
"av_perms_def : CLASS identifier '{' identifier_list '}'",
"av_perms_def : CLASS identifier INHERITS identifier",
"av_perms_def : CLASS identifier INHERITS identifier '{' identifier_list '}'",
"opt_mls : mls",
"opt_mls :",
"mls : sensitivities dominance opt_categories levels mlspolicy",
"sensitivities : sensitivity_def",
"sensitivities : sensitivities sensitivity_def",
"sensitivity_def : SENSITIVITY identifier alias_def ';'",
"sensitivity_def : SENSITIVITY identifier ';'",
"alias_def : ALIAS names",
"dominance : DOMINANCE identifier",
"dominance : DOMINANCE '{' identifier_list '}'",
"opt_categories : categories",
"opt_categories :",
"categories : category_def",
"categories : categories category_def",
"category_def : CATEGORY identifier alias_def ';'",
"category_def : CATEGORY identifier ';'",
"levels : level_def",
"levels : levels level_def",
"level_def : LEVEL identifier ':' id_comma_list ';'",
"level_def : LEVEL identifier ';'",
"mlspolicy : mlspolicy_decl",
"mlspolicy : mlspolicy mlspolicy_decl",
"mlspolicy_decl : mlsconstraint_def",
"mlspolicy_decl : mlsvalidatetrans_def",
"mlsconstraint_def : MLSCONSTRAIN names names cexpr ';'",
"mlsvalidatetrans_def : MLSVALIDATETRANS names cexpr ';'",
"te_rbac : te_rbac_decl",
"te_rbac : te_rbac te_rbac_decl",
"te_rbac_decl : te_decl",
"te_rbac_decl : rbac_decl",
"te_rbac_decl : cond_stmt_def",
"te_rbac_decl : optional_block",
"te_rbac_decl : ';'",
"rbac_decl : role_type_def",
"rbac_decl : role_dominance",
"rbac_decl : role_trans_def",
"rbac_decl : role_allow_def",
"te_decl : attribute_def",
"te_decl : type_def",
"te_decl : typealias_def",
"te_decl : typeattribute_def",
"te_decl : bool_def",
"te_decl : transition_def",
"te_decl : range_trans_def",
"te_decl : te_avtab_def",
"attribute_def : ATTRIBUTE identifier ';'",
"type_def : TYPE identifier alias_def opt_attr_list ';'",
"type_def : TYPE identifier opt_attr_list ';'",
"typealias_def : TYPEALIAS identifier alias_def ';'",
"typeattribute_def : TYPEATTRIBUTE identifier id_comma_list ';'",
"opt_attr_list : ',' id_comma_list",
"opt_attr_list :",
"bool_def : BOOL identifier bool_val ';'",
"bool_val : CTRUE",
"bool_val : CFALSE",
"cond_stmt_def : IF cond_expr '{' cond_pol_list '}' cond_else",
"cond_else : ELSE '{' cond_pol_list '}'",
"cond_else :",
"cond_expr : '(' cond_expr ')'",
"cond_expr : NOT cond_expr",
"cond_expr : cond_expr AND cond_expr",
"cond_expr : cond_expr OR cond_expr",
"cond_expr : cond_expr XOR cond_expr",
"cond_expr : cond_expr EQUALS cond_expr",
"cond_expr : cond_expr NOTEQUAL cond_expr",
"cond_expr : cond_expr_prim",
"cond_expr_prim : identifier",
"cond_pol_list : cond_pol_list cond_rule_def",
"cond_pol_list :",
"cond_rule_def : cond_transition_def",
"cond_rule_def : cond_te_avtab_def",
"cond_rule_def : require_block",
"cond_transition_def : TYPE_TRANSITION names names ':' names identifier ';'",
"cond_transition_def : TYPE_MEMBER names names ':' names identifier ';'",
"cond_transition_def : TYPE_CHANGE names names ':' names identifier ';'",
"cond_te_avtab_def : cond_allow_def",
"cond_te_avtab_def : cond_auditallow_def",
"cond_te_avtab_def : cond_auditdeny_def",
"cond_te_avtab_def : cond_dontaudit_def",
"cond_allow_def : ALLOW names names ':' names names ';'",
"cond_auditallow_def : AUDITALLOW names names ':' names names ';'",
"cond_auditdeny_def : AUDITDENY names names ':' names names ';'",
"cond_dontaudit_def : DONTAUDIT names names ':' names names ';'",
"transition_def : TYPE_TRANSITION names names ':' names identifier ';'",
"transition_def : TYPE_MEMBER names names ':' names identifier ';'",
"transition_def : TYPE_CHANGE names names ':' names identifier ';'",
"range_trans_def : RANGE_TRANSITION names names mls_range_def ';'",
"range_trans_def : RANGE_TRANSITION names names ':' names mls_range_def ';'",
"te_avtab_def : allow_def",
"te_avtab_def : auditallow_def",
"te_avtab_def : auditdeny_def",
"te_avtab_def : dontaudit_def",
"te_avtab_def : neverallow_def",
"allow_def : ALLOW names names ':' names names ';'",
"auditallow_def : AUDITALLOW names names ':' names names ';'",
"auditdeny_def : AUDITDENY names names ':' names names ';'",
"dontaudit_def : DONTAUDIT names names ':' names names ';'",
"neverallow_def : NEVERALLOW names names ':' names names ';'",
"role_type_def : ROLE identifier TYPES names ';'",
"role_type_def : ROLE identifier ';'",
"role_dominance : DOMINANCE '{' roles '}'",
"role_trans_def : ROLE_TRANSITION names names identifier ';'",
"role_allow_def : ALLOW names names ';'",
"roles : role_def",
"roles : roles role_def",
"role_def : ROLE identifier_push ';'",
"role_def : ROLE identifier_push '{' roles '}'",
"opt_constraints : constraints",
"opt_constraints :",
"constraints : constraint_decl",
"constraints : constraints constraint_decl",
"constraint_decl : constraint_def",
"constraint_decl : validatetrans_def",
"constraint_def : CONSTRAIN names names cexpr ';'",
"validatetrans_def : VALIDATETRANS names cexpr ';'",
"cexpr : '(' cexpr ')'",
"cexpr : NOT cexpr",
"cexpr : cexpr AND cexpr",
"cexpr : cexpr OR cexpr",
"cexpr : cexpr_prim",
"cexpr_prim : U1 op U2",
"cexpr_prim : R1 role_mls_op R2",
"cexpr_prim : T1 op T2",
"$$4 :",
"cexpr_prim : U1 op $$4 names_push",
"$$5 :",
"cexpr_prim : U2 op $$5 names_push",
"$$6 :",
"cexpr_prim : U3 op $$6 names_push",
"$$7 :",
"cexpr_prim : R1 op $$7 names_push",
"$$8 :",
"cexpr_prim : R2 op $$8 names_push",
"$$9 :",
"cexpr_prim : R3 op $$9 names_push",
"$$10 :",
"cexpr_prim : T1 op $$10 names_push",
"$$11 :",
"cexpr_prim : T2 op $$11 names_push",
"$$12 :",
"cexpr_prim : T3 op $$12 names_push",
"cexpr_prim : SAMEUSER",
"$$13 :",
"cexpr_prim : SOURCE ROLE $$13 names_push",
"$$14 :",
"cexpr_prim : TARGET ROLE $$14 names_push",
"cexpr_prim : ROLE role_mls_op",
"$$15 :",
"cexpr_prim : SOURCE TYPE $$15 names_push",
"$$16 :",
"cexpr_prim : TARGET TYPE $$16 names_push",
"cexpr_prim : L1 role_mls_op L2",
"cexpr_prim : L1 role_mls_op H2",
"cexpr_prim : H1 role_mls_op L2",
"cexpr_prim : H1 role_mls_op H2",
"cexpr_prim : L1 role_mls_op H1",
"cexpr_prim : L2 role_mls_op H2",
"op : EQUALS",
"op : NOTEQUAL",
"role_mls_op : op",
"role_mls_op : DOM",
"role_mls_op : DOMBY",
"role_mls_op : INCOMP",
"users : user_def",
"users : users user_def",
"user_def : USER identifier ROLES names opt_mls_user ';'",
"opt_mls_user : LEVEL mls_level_def RANGE mls_range_def",
"opt_mls_user :",
"initial_sid_contexts : initial_sid_context_def",
"initial_sid_contexts : initial_sid_contexts initial_sid_context_def",
"initial_sid_context_def : SID identifier security_context_def",
"opt_fs_contexts : fs_contexts",
"opt_fs_contexts :",
"fs_contexts : fs_context_def",
"fs_contexts : fs_contexts fs_context_def",
"fs_context_def : FSCON number number security_context_def security_context_def",
"net_contexts : opt_port_contexts opt_netif_contexts opt_node_contexts",
"opt_port_contexts : port_contexts",
"opt_port_contexts :",
"port_contexts : port_context_def",
"port_contexts : port_contexts port_context_def",
"port_context_def : PORTCON identifier number security_context_def",
"port_context_def : PORTCON identifier number '-' number security_context_def",
"opt_netif_contexts : netif_contexts",
"opt_netif_contexts :",
"netif_contexts : netif_context_def",
"netif_contexts : netif_contexts netif_context_def",
"netif_context_def : NETIFCON identifier security_context_def security_context_def",
"opt_node_contexts : node_contexts",
"opt_node_contexts :",
"node_contexts : node_context_def",
"node_contexts : node_contexts node_context_def",
"node_context_def : NODECON ipv4_addr_def ipv4_addr_def security_context_def",
"node_context_def : NODECON ipv6_addr ipv6_addr security_context_def",
"opt_fs_uses : fs_uses",
"opt_fs_uses :",
"fs_uses : fs_use_def",
"fs_uses : fs_uses fs_use_def",
"fs_use_def : FSUSEXATTR identifier security_context_def ';'",
"fs_use_def : FSUSETASK identifier security_context_def ';'",
"fs_use_def : FSUSETRANS identifier security_context_def ';'",
"opt_genfs_contexts : genfs_contexts",
"opt_genfs_contexts :",
"genfs_contexts : genfs_context_def",
"genfs_contexts : genfs_contexts genfs_context_def",
"genfs_context_def : GENFSCON identifier path '-' identifier security_context_def",
"$$17 :",
"genfs_context_def : GENFSCON identifier path '-' '-' $$17 security_context_def",
"genfs_context_def : GENFSCON identifier path security_context_def",
"ipv4_addr_def : number '.' number '.' number '.' number",
"security_context_def : identifier ':' identifier ':' identifier opt_mls_range_def",
"opt_mls_range_def : ':' mls_range_def",
"opt_mls_range_def :",
"mls_range_def : mls_level_def '-' mls_level_def",
"mls_range_def : mls_level_def",
"mls_level_def : identifier ':' id_comma_list",
"mls_level_def : identifier",
"id_comma_list : identifier",
"id_comma_list : id_comma_list ',' identifier",
"tilde : '~'",
"asterisk : '*'",
"names : identifier",
"names : nested_id_set",
"names : asterisk",
"names : tilde identifier",
"names : tilde nested_id_set",
"$$18 :",
"names : identifier '-' $$18 identifier",
"tilde_push : tilde",
"asterisk_push : asterisk",
"names_push : identifier_push",
"names_push : '{' identifier_list_push '}'",
"names_push : asterisk_push",
"names_push : tilde_push identifier_push",
"names_push : tilde_push '{' identifier_list_push '}'",
"identifier_list_push : identifier_push",
"identifier_list_push : identifier_list_push identifier_push",
"identifier_push : IDENTIFIER",
"identifier_list : identifier",
"identifier_list : identifier_list identifier",
"nested_id_set : '{' nested_id_list '}'",
"nested_id_list : nested_id_element",
"nested_id_list : nested_id_list nested_id_element",
"nested_id_element : identifier",
"$$19 :",
"nested_id_element : '-' $$19 identifier",
"nested_id_element : nested_id_set",
"identifier : IDENTIFIER",
"path : PATH",
"number : NUMBER",
"ipv6_addr : IPV6_ADDR",
"module_policy : module_def avrules_block",
"module_def : MODULE identifier version_identifier ';'",
"version_identifier : VERSION_IDENTIFIER",
"avrules_block : avrule_decls avrule_user_defs",
"avrule_decls : avrule_decls avrule_decl",
"avrule_decls : avrule_decl",
"avrule_decl : rbac_decl",
"avrule_decl : te_decl",
"avrule_decl : cond_stmt_def",
"avrule_decl : require_block",
"avrule_decl : optional_block",
"avrule_decl : ';'",
"require_block : REQUIRE '{' require_list '}'",
"require_list : require_list require_decl",
"require_list : require_decl",
"require_decl : require_class ';'",
"require_decl : require_decl_def require_id_list ';'",
"require_class : CLASS identifier names",
"require_decl_def : ROLE",
"require_decl_def : TYPE",
"require_decl_def : ATTRIBUTE",
"require_decl_def : USER",
"require_decl_def : BOOL",
"require_decl_def : SENSITIVITY",
"require_decl_def : CATEGORY",
"require_id_list : identifier",
"require_id_list : require_id_list ',' identifier",
"$$20 :",
"optional_block : optional_decl '{' avrules_block '}' $$20 optional_else",
"optional_else : else_decl '{' avrules_block '}'",
"optional_else :",
"optional_decl : OPTIONAL",
"else_decl : ELSE",
"avrule_user_defs : user_def avrule_user_defs",
"avrule_user_defs :",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static int      yystacksize;
#line 845 "policy_parse.y"

/* initialize all of the state variables for the scanner/parser */
void init_parser(int pass_number)
{
	policydb_lineno = 1;
	source_lineno = 1;
	policydb_errors = 0;
	pass = pass_number;
}

void yyerror2(char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	vsnprintf(errormsg, ERRORMSG_LEN, fmt, ap);
	yyerror(errormsg);
	va_end(ap);
}

#define DEBUG 1

static int insert_separator(int push)
{
	int error;

	if (push)
		error = queue_push(id_queue, 0);
	else
		error = queue_insert(id_queue, 0);

	if (error) {
		yyerror("queue overflow");
		return -1;
	}
	return 0;
}

static int insert_id(char *id, int push)
{
	char *newid = 0;
	int error;

	newid = (char *)malloc(strlen(id) + 1);
	if (!newid) {
		yyerror("out of memory");
		return -1;
	}
	strcpy(newid, id);
	if (push)
		error = queue_push(id_queue, (queue_element_t) newid);
	else
		error = queue_insert(id_queue, (queue_element_t) newid);

	if (error) {
		yyerror("queue overflow");
		free(newid);
		return -1;
	}
	return 0;
}

/* If the identifier has a dot within it and that its first character
   is not a dot then return 1, else return 0. */
static int id_has_dot(char *id)
{
	if (strchr(id, '.') >= id + 1) {
		return 1;
	}
	return 0;
}

static int define_class(void)
{
	char *id = 0;
	class_datum_t *datum = 0;
	int ret;
	uint32_t value;

	if (pass == 2) {
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no class name for class definition?");
		return -1;
	}
	datum = (class_datum_t *) malloc(sizeof(class_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(class_datum_t));
	ret = declare_symbol(SYM_CLASSES, id, datum, &value, &value);
	switch (ret) {
	case -3:{
			yyerror("Out of memory!");
			goto bad;
		}
	case -2:{
			yyerror2("duplicate declaration of class %s", id);
			goto bad;
		}
	case -1:{
			yyerror("could not declare class here");
			goto bad;
		}
	case 0:
	case 1:{
			break;
		}
	default:{
			assert(0);	/* should never get here */
		}
	}
	datum->s.value = value;
	return 0;

      bad:
	if (id)
		free(id);
	if (datum)
		free(datum);
	return -1;
}

static int define_initial_sid(void)
{
	char *id = 0;
	ocontext_t *newc = 0, *c, *head;

	if (pass == 2) {
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no sid name for SID definition?");
		return -1;
	}
	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		goto bad;
	}
	memset(newc, 0, sizeof(ocontext_t));
	newc->u.name = id;
	context_init(&newc->context[0]);
	head = policydbp->ocontexts[OCON_ISID];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate initial SID %s", id);
			yyerror(errormsg);
			goto bad;
		}
	}

	if (head) {
		newc->sid[0] = head->sid[0] + 1;
	} else {
		newc->sid[0] = 1;
	}
	newc->next = head;
	policydbp->ocontexts[OCON_ISID] = newc;

	return 0;

      bad:
	if (id)
		free(id);
	if (newc)
		free(newc);
	return -1;
}

static int define_common_perms(void)
{
	char *id = 0, *perm = 0;
	common_datum_t *comdatum = 0;
	perm_datum_t *perdatum = 0;
	int ret;

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no common name for common perm definition?");
		return -1;
	}
	comdatum = hashtab_search(policydbp->p_commons.table, id);
	if (comdatum) {
		snprintf(errormsg, ERRORMSG_LEN,
			 "duplicate declaration for common %s\n", id);
		yyerror(errormsg);
		return -1;
	}
	comdatum = (common_datum_t *) malloc(sizeof(common_datum_t));
	if (!comdatum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(comdatum, 0, sizeof(common_datum_t));
	ret = hashtab_insert(policydbp->p_commons.table,
			     (hashtab_key_t) id, (hashtab_datum_t) comdatum);

	if (ret == SEPOL_EEXIST) {
		yyerror("duplicate common definition");
		goto bad;
	}
	if (ret == SEPOL_ENOMEM) {
		yyerror("hash table overflow");
		goto bad;
	}
	comdatum->s.value = policydbp->p_commons.nprim + 1;
	if (symtab_init(&comdatum->permissions, PERM_SYMTAB_SIZE)) {
		yyerror("out of memory");
		goto bad;
	}
	policydbp->p_commons.nprim++;
	while ((perm = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) malloc(sizeof(perm_datum_t));
		if (!perdatum) {
			yyerror("out of memory");
			goto bad_perm;
		}
		memset(perdatum, 0, sizeof(perm_datum_t));
		perdatum->s.value = comdatum->permissions.nprim + 1;

		if (perdatum->s.value > (sizeof(sepol_access_vector_t) * 8)) {
			yyerror
			    ("too many permissions to fit in an access vector");
			goto bad_perm;
		}
		ret = hashtab_insert(comdatum->permissions.table,
				     (hashtab_key_t) perm,
				     (hashtab_datum_t) perdatum);

		if (ret == SEPOL_EEXIST) {
			sprintf(errormsg,
				"duplicate permission %s in common %s", perm,
				id);
			yyerror(errormsg);
			goto bad_perm;
		}
		if (ret == SEPOL_ENOMEM) {
			yyerror("hash table overflow");
			goto bad_perm;
		}
		comdatum->permissions.nprim++;
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (comdatum)
		free(comdatum);
	return -1;

      bad_perm:
	if (perm)
		free(perm);
	if (perdatum)
		free(perdatum);
	return -1;
}

static int define_av_perms(int inherits)
{
	char *id;
	class_datum_t *cladatum;
	common_datum_t *comdatum;
	perm_datum_t *perdatum = 0, *perdatum2 = 0;
	int ret;

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no tclass name for av perm definition?");
		return -1;
	}
	cladatum = (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						    (hashtab_key_t) id);
	if (!cladatum) {
		sprintf(errormsg, "class %s is not defined", id);
		yyerror(errormsg);
		goto bad;
	}
	free(id);

	if (cladatum->comdatum || cladatum->permissions.nprim) {
		yyerror("duplicate access vector definition");
		return -1;
	}
	if (symtab_init(&cladatum->permissions, PERM_SYMTAB_SIZE)) {
		yyerror("out of memory");
		return -1;
	}
	if (inherits) {
		id = (char *)queue_remove(id_queue);
		if (!id) {
			yyerror
			    ("no inherits name for access vector definition?");
			return -1;
		}
		comdatum =
		    (common_datum_t *) hashtab_search(policydbp->p_commons.
						      table,
						      (hashtab_key_t) id);

		if (!comdatum) {
			sprintf(errormsg, "common %s is not defined", id);
			yyerror(errormsg);
			goto bad;
		}
		cladatum->comkey = id;
		cladatum->comdatum = comdatum;

		/*
		 * Class-specific permissions start with values 
		 * after the last common permission.
		 */
		cladatum->permissions.nprim += comdatum->permissions.nprim;
	}
	while ((id = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) malloc(sizeof(perm_datum_t));
		if (!perdatum) {
			yyerror("out of memory");
			goto bad;
		}
		memset(perdatum, 0, sizeof(perm_datum_t));
		perdatum->s.value = ++cladatum->permissions.nprim;

		if (perdatum->s.value > (sizeof(sepol_access_vector_t) * 8)) {
			yyerror
			    ("too many permissions to fit in an access vector");
			goto bad;
		}
		if (inherits) {
			/*
			 * Class-specific permissions and 
			 * common permissions exist in the same
			 * name space.
			 */
			perdatum2 =
			    (perm_datum_t *) hashtab_search(cladatum->comdatum->
							    permissions.table,
							    (hashtab_key_t) id);
			if (perdatum2) {
				sprintf(errormsg,
					"permission %s conflicts with an inherited permission",
					id);
				yyerror(errormsg);
				goto bad;
			}
		}
		ret = hashtab_insert(cladatum->permissions.table,
				     (hashtab_key_t) id,
				     (hashtab_datum_t) perdatum);

		if (ret == SEPOL_EEXIST) {
			sprintf(errormsg, "duplicate permission %s", id);
			yyerror(errormsg);
			goto bad;
		}
		if (ret == SEPOL_ENOMEM) {
			yyerror("hash table overflow");
			goto bad;
		}
		if (add_perm_to_class(perdatum->s.value, cladatum->s.value)) {
			yyerror("out of memory");
			goto bad;
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (perdatum)
		free(perdatum);
	return -1;
}

static int define_sens(void)
{
	char *id;
	mls_level_t *level = 0;
	level_datum_t *datum = 0, *aliasdatum = 0;
	int ret;
	uint32_t value;		/* dummy variable -- its value is never used */

	if (!mlspol) {
		yyerror("sensitivity definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no sensitivity name for sensitivity definition?");
		return -1;
	}
	if (id_has_dot(id)) {
		yyerror("sensitivity identifiers may not contain periods");
		goto bad;
	}
	level = (mls_level_t *) malloc(sizeof(mls_level_t));
	if (!level) {
		yyerror("out of memory");
		goto bad;
	}
	mls_level_init(level);
	level->sens = 0;	/* actual value set in define_dominance */
	ebitmap_init(&level->cat);	/* actual value set in define_level */

	datum = (level_datum_t *) malloc(sizeof(level_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	level_datum_init(datum);
	datum->isalias = FALSE;
	datum->level = level;

	ret = declare_symbol(SYM_LEVELS, id, datum, &value, &value);
	switch (ret) {
	case -3:{
			yyerror("Out of memory!");
			goto bad;
		}
	case -2:{
			yyerror("duplicate declaration of sensitivity level");
			goto bad;
		}
	case -1:{
			yyerror("could not declare sensitivity level here");
			goto bad;
		}
	case 0:
	case 1:{
			break;
		}
	default:{
			assert(0);	/* should never get here */
		}
	}

	while ((id = queue_remove(id_queue))) {
		if (id_has_dot(id)) {
			yyerror("sensitivity aliases may not contain periods");
			goto bad_alias;
		}
		aliasdatum = (level_datum_t *) malloc(sizeof(level_datum_t));
		if (!aliasdatum) {
			yyerror("out of memory");
			goto bad_alias;
		}
		level_datum_init(aliasdatum);
		aliasdatum->isalias = TRUE;
		aliasdatum->level = level;

		ret = declare_symbol(SYM_LEVELS, id, aliasdatum, NULL, &value);
		switch (ret) {
		case -3:{
				yyerror("Out of memory!");
				goto bad_alias;
			}
		case -2:{
				yyerror
				    ("duplicate declaration of sensitivity alias");
				goto bad_alias;
			}
		case -1:{
				yyerror
				    ("could not declare sensitivity alias here");
				goto bad_alias;
			}
		case 0:
		case 1:{
				break;
			}
		default:{
				assert(0);	/* should never get here */
			}
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (level)
		free(level);
	if (datum) {
		level_datum_destroy(datum);
		free(datum);
	}
	return -1;

      bad_alias:
	if (id)
		free(id);
	if (aliasdatum) {
		level_datum_destroy(aliasdatum);
		free(aliasdatum);
	}
	return -1;
}

static int define_dominance(void)
{
	level_datum_t *datum;
	int order;
	char *id;

	if (!mlspol) {
		yyerror("dominance definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	order = 0;
	while ((id = (char *)queue_remove(id_queue))) {
		datum =
		    (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
		if (!datum) {
			sprintf(errormsg,
				"unknown sensitivity %s used in dominance definition",
				id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (datum->level->sens != 0) {
			sprintf(errormsg,
				"sensitivity %s occurs multiply in dominance definition",
				id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		datum->level->sens = ++order;

		/* no need to keep sensitivity name */
		free(id);
	}

	if (order != policydbp->p_levels.nprim) {
		yyerror
		    ("all sensitivities must be specified in dominance definition");
		return -1;
	}
	return 0;
}

static int define_category(void)
{
	char *id;
	cat_datum_t *datum = 0, *aliasdatum = 0;
	int ret;
	uint32_t value;

	if (!mlspol) {
		yyerror("category definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no category name for category definition?");
		return -1;
	}
	if (id_has_dot(id)) {
		yyerror("category identifiers may not contain periods");
		goto bad;
	}
	datum = (cat_datum_t *) malloc(sizeof(cat_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	cat_datum_init(datum);
	datum->isalias = FALSE;

	ret = declare_symbol(SYM_CATS, id, datum, &value, &value);
	switch (ret) {
	case -3:{
			yyerror("Out of memory!");
			goto bad;
		}
	case -2:{
			yyerror("duplicate declaration of category");
			goto bad;
		}
	case -1:{
			yyerror("could not declare category here");
			goto bad;
		}
	case 0:
	case 1:{
			break;
		}
	default:{
			assert(0);	/* should never get here */
		}
	}
	datum->s.value = value;

	while ((id = queue_remove(id_queue))) {
		if (id_has_dot(id)) {
			yyerror("category aliases may not contain periods");
			goto bad_alias;
		}
		aliasdatum = (cat_datum_t *) malloc(sizeof(cat_datum_t));
		if (!aliasdatum) {
			yyerror("out of memory");
			goto bad_alias;
		}
		cat_datum_init(aliasdatum);
		aliasdatum->isalias = TRUE;
		aliasdatum->s.value = datum->s.value;

		ret =
		    declare_symbol(SYM_CATS, id, aliasdatum, NULL,
				   &datum->s.value);
		switch (ret) {
		case -3:{
				yyerror("Out of memory!");
				goto bad_alias;
			}
		case -2:{
				yyerror
				    ("duplicate declaration of category aliases");
				goto bad_alias;
			}
		case -1:{
				yyerror
				    ("could not declare category aliases here");
				goto bad_alias;
			}
		case 0:
		case 1:{
				break;
			}
		default:{
				assert(0);	/* should never get here */
			}
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (datum) {
		cat_datum_destroy(datum);
		free(datum);
	}
	return -1;

      bad_alias:
	if (id)
		free(id);
	if (aliasdatum) {
		cat_datum_destroy(aliasdatum);
		free(aliasdatum);
	}
	return -1;
}

static int clone_level(hashtab_key_t key, hashtab_datum_t datum, void *arg)
{
	level_datum_t *levdatum = (level_datum_t *) datum;
	mls_level_t *level = (mls_level_t *) arg, *newlevel;

	if (levdatum->level == level) {
		levdatum->defined = 1;
		if (!levdatum->isalias)
			return 0;
		newlevel = (mls_level_t *) malloc(sizeof(mls_level_t));
		if (!newlevel)
			return -1;
		if (mls_level_cpy(newlevel, level)) {
			free(newlevel);
			return -1;
		}
		levdatum->level = newlevel;
	}
	return 0;
}

static int define_level(void)
{
	char *id;
	level_datum_t *levdatum;

	if (!mlspol) {
		yyerror("level definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no level name for level definition?");
		return -1;
	}
	levdatum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						    (hashtab_key_t) id);
	if (!levdatum) {
		sprintf(errormsg,
			"unknown sensitivity %s used in level definition", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (ebitmap_length(&levdatum->level->cat)) {
		sprintf(errormsg,
			"sensitivity %s used in multiple level definitions",
			id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	free(id);

	levdatum->defined = 1;

	while ((id = queue_remove(id_queue))) {
		cat_datum_t *cdatum;
		int range_start, range_end, i;

		if (id_has_dot(id)) {
			char *id_start = id;
			char *id_end = strchr(id, '.');

			*(id_end++) = '\0';

			cdatum =
			    (cat_datum_t *) hashtab_search(policydbp->p_cats.
							   table,
							   (hashtab_key_t)
							   id_start);
			if (!cdatum) {
				sprintf(errormsg, "unknown category %s",
					id_start);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			range_start = cdatum->s.value - 1;
			cdatum =
			    (cat_datum_t *) hashtab_search(policydbp->p_cats.
							   table,
							   (hashtab_key_t)
							   id_end);
			if (!cdatum) {
				sprintf(errormsg, "unknown category %s",
					id_end);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			range_end = cdatum->s.value - 1;

			if (range_end < range_start) {
				sprintf(errormsg, "category range is invalid");
				yyerror(errormsg);
				free(id);
				return -1;
			}
		} else {
			cdatum =
			    (cat_datum_t *) hashtab_search(policydbp->p_cats.
							   table,
							   (hashtab_key_t) id);
			range_start = range_end = cdatum->s.value - 1;
		}

		for (i = range_start; i <= range_end; i++) {
			if (ebitmap_set_bit(&levdatum->level->cat, i, TRUE)) {
				yyerror("out of memory");
				free(id);
				return -1;
			}
		}

		free(id);
	}

	if (hashtab_map
	    (policydbp->p_levels.table, clone_level, levdatum->level)) {
		yyerror("out of memory");
		return -1;
	}

	return 0;
}

static int define_attrib(void)
{
	if (pass == 2) {
		free(queue_remove(id_queue));
		return 0;
	}

	if (declare_type(TRUE, TRUE) == NULL) {
		return -1;
	}
	return 0;
}

static int add_aliases_to_type(type_datum_t * type)
{
	char *id;
	type_datum_t *aliasdatum = NULL;
	int ret;
	while ((id = queue_remove(id_queue))) {
		if (id_has_dot(id)) {
			free(id);
			yyerror
			    ("type alias identifiers may not contain periods");
			return -1;
		}
		aliasdatum = (type_datum_t *) malloc(sizeof(type_datum_t));
		if (!aliasdatum) {
			free(id);
			yyerror("Out of memory!");
			return -1;
		}
		memset(aliasdatum, 0, sizeof(type_datum_t));
		aliasdatum->s.value = type->s.value;

		ret = declare_symbol(SYM_TYPES, id, aliasdatum,
				     NULL, &aliasdatum->s.value);
		switch (ret) {
		case -3:{
				yyerror("Out of memory!");
				goto cleanup;
			}
		case -2:{
				yyerror2("duplicate declaration of alias %s",
					 id);
				goto cleanup;
			}
		case -1:{
				yyerror("could not declare alias here");
				goto cleanup;
			}
		case 0:
		case 1:{
				break;
			}
		default:{
				assert(0);	/* should never get here */
			}
		}
	}
	return 0;
      cleanup:
	free(id);
	type_datum_destroy(aliasdatum);
	free(aliasdatum);
	return -1;
}

static int define_typealias(void)
{
	char *id;
	type_datum_t *t;

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for typealias definition?");
		return -1;
	}

	if (!is_id_in_scope(SYM_TYPES, id)) {
		yyerror2("type %s is not within scope", id);
		free(id);
		return -1;
	}
	t = hashtab_search(policydbp->p_types.table, id);
	if (!t || t->flavor == TYPE_ATTRIB) {
		sprintf(errormsg,
			"unknown type %s, or it was already declared as an attribute",
			id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	return add_aliases_to_type(t);
}

static int define_typeattribute(void)
{
	char *id;
	type_datum_t *t, *attr;

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for typeattribute definition?");
		return -1;
	}

	if (!is_id_in_scope(SYM_TYPES, id)) {
		yyerror2("type %s is not within scope", id);
		free(id);
		return -1;
	}
	t = hashtab_search(policydbp->p_types.table, id);
	if (!t || t->flavor == TYPE_ATTRIB) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	while ((id = queue_remove(id_queue))) {
		if (!is_id_in_scope(SYM_TYPES, id)) {
			yyerror2("attribute %s is not within scope", id);
			free(id);
			return -1;
		}
		attr = hashtab_search(policydbp->p_types.table, id);
		if (!attr) {
			sprintf(errormsg, "attribute %s is not declared", id);
			/* treat it as a fatal error */
			yyerror(errormsg);
			free(id);
			return -1;
		}

		if (attr->flavor != TYPE_ATTRIB) {
			sprintf(errormsg, "%s is a type, not an attribute", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}

		if ((attr = get_local_type(id, attr->s.value, 1)) == NULL) {
			yyerror("Out of memory!");
			return -1;
		}

		if (ebitmap_set_bit(&attr->types, (t->s.value - 1), TRUE)) {
			yyerror("out of memory");
			return -1;
		}
	}

	return 0;
}

static int define_type(int alias)
{
	char *id;
	type_datum_t *datum, *attr;
	int newattr = 0;

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		if (alias) {
			while ((id = queue_remove(id_queue)))
				free(id);
		}
		return 0;
	}

	if ((datum = declare_type(TRUE, FALSE)) == NULL) {
		return -1;
	}

	if (alias) {
		if (add_aliases_to_type(datum) == -1) {
			return -1;
		}
	}

	while ((id = queue_remove(id_queue))) {
		if (!is_id_in_scope(SYM_TYPES, id)) {
			yyerror2("attribute %s is not within scope", id);
			free(id);
			return -1;
		}
		attr = hashtab_search(policydbp->p_types.table, id);
		if (!attr) {
			sprintf(errormsg, "attribute %s is not declared", id);

			/* treat it as a fatal error */
			yyerror(errormsg);
			return -1;
		} else {
			newattr = 0;
		}

		if (attr->flavor != TYPE_ATTRIB) {
			sprintf(errormsg, "%s is a type, not an attribute", id);
			yyerror(errormsg);
			return -1;
		}

		if ((attr = get_local_type(id, attr->s.value, 1)) == NULL) {
			yyerror("Out of memory!");
			return -1;
		}

		if (ebitmap_set_bit(&attr->types, datum->s.value - 1, TRUE)) {
			yyerror("Out of memory");
			return -1;
		}
	}

	return 0;
}

struct val_to_name {
	unsigned int val;
	char *name;
};

/* Adds a type, given by its textual name, to a typeset.  If *add is
   0, then add the type to the negative set; otherwise if *add is 1
   then add it to the positive side. */
static int set_types(type_set_t * set, char *id, int *add, char starallowed)
{
	type_datum_t *t;

	if (strcmp(id, "*") == 0) {
		if (!starallowed) {
			yyerror("* not allowed in this type of rule");
			return -1;
		}
		/* set TYPE_STAR flag */
		set->flags = TYPE_STAR;
		free(id);
		*add = 1;
		return 0;
	}

	if (strcmp(id, "~") == 0) {
		if (!starallowed) {
			yyerror("~ not allowed in this type of rule");
			return -1;
		}
		/* complement the set */
		set->flags = TYPE_COMP;
		free(id);
		*add = 1;
		return 0;
	}

	if (strcmp(id, "-") == 0) {
		*add = 0;
		free(id);
		return 0;
	}

	if (!is_id_in_scope(SYM_TYPES, id)) {
		yyerror2("type %s is not within scope", id);
		free(id);
		return -1;
	}
	t = hashtab_search(policydbp->p_types.table, id);
	if (!t) {
		snprintf(errormsg, ERRORMSG_LEN, "unknown type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	if (*add == 0) {
		if (ebitmap_set_bit(&set->negset, t->s.value - 1, TRUE))
			goto oom;
	} else {
		if (ebitmap_set_bit(&set->types, t->s.value - 1, TRUE))
			goto oom;
	}
	free(id);
	*add = 1;
	return 0;
      oom:
	yyerror("Out of memory");
	free(id);
	return -1;
}

static int define_compute_type_helper(int which, avrule_t ** rule)
{
	char *id;
	type_datum_t *datum;
	class_datum_t *cladatum;
	ebitmap_t tclasses;
	ebitmap_node_t *node;
	avrule_t *avrule;
	class_perm_node_t *perm;
	int i, add = 1;

	avrule = malloc(sizeof(avrule_t));
	if (!avrule) {
		yyerror("out of memory");
		return -1;
	}
	avrule_init(avrule);
	avrule->specified = which;
	avrule->line = policydb_lineno;

	while ((id = queue_remove(id_queue))) {
		if (set_types(&avrule->stypes, id, &add, 0))
			return -1;
	}
	add = 1;
	while ((id = queue_remove(id_queue))) {
		if (set_types(&avrule->ttypes, id, &add, 0))
			return -1;
	}

	ebitmap_init(&tclasses);
	while ((id = queue_remove(id_queue))) {
		if (!is_id_in_scope(SYM_CLASSES, id)) {
			yyerror2("class %s is not within scope", id);
			free(id);
			goto bad;
		}
		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) {
			sprintf(errormsg, "unknown class %s", id);
			yyerror(errormsg);
			goto bad;
		}
		if (ebitmap_set_bit(&tclasses, cladatum->s.value - 1, TRUE)) {
			yyerror("Out of memory");
			goto bad;
		}
		free(id);
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no newtype?");
		goto bad;
	}
	if (!is_id_in_scope(SYM_TYPES, id)) {
		yyerror2("type %s is not within scope", id);
		free(id);
		goto bad;
	}
	datum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						(hashtab_key_t) id);
	if (!datum || datum->flavor == TYPE_ATTRIB) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		goto bad;
	}

	ebitmap_for_each_bit(&tclasses, node, i) {
		if (ebitmap_node_get_bit(node, i)) {
			perm = malloc(sizeof(class_perm_node_t));
			if (!perm) {
				yyerror("out of memory");
				return -1;
			}
			class_perm_node_init(perm);
			perm->class = i + 1;
			perm->data = datum->s.value;
			perm->next = avrule->perms;
			avrule->perms = perm;
		}
	}
	ebitmap_destroy(&tclasses);

	*rule = avrule;
	return 0;

      bad:
	avrule_destroy(avrule);
	free(avrule);
	return -1;
}

static int define_compute_type(int which)
{
	char *id;
	avrule_t *avrule;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	if (define_compute_type_helper(which, &avrule))
		return -1;

	append_avrule(avrule);
	return 0;
}

static avrule_t *define_cond_compute_type(int which)
{
	char *id;
	avrule_t *avrule;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return (avrule_t *) 1;
	}

	if (define_compute_type_helper(which, &avrule))
		return COND_ERR;

	return avrule;
}

static int define_bool(void)
{
	char *id, *bool_value;
	cond_bool_datum_t *datum;
	int ret;
	uint32_t value;

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no identifier for bool definition?");
		return -1;
	}
	if (id_has_dot(id)) {
		free(id);
		yyerror("boolean identifiers may not contain periods");
		return -1;
	}
	datum = (cond_bool_datum_t *) malloc(sizeof(cond_bool_datum_t));
	if (!datum) {
		yyerror("out of memory");
		free(id);
		return -1;
	}
	memset(datum, 0, sizeof(cond_bool_datum_t));
	ret = declare_symbol(SYM_BOOLS, id, datum, &value, &value);
	switch (ret) {
	case -3:{
			yyerror("Out of memory!");
			goto cleanup;
		}
	case -2:{
			yyerror2("duplicate declaration of boolean %s", id);
			goto cleanup;
		}
	case -1:{
			yyerror("could not declare boolean here");
			goto cleanup;
		}
	case 0:
	case 1:{
			break;
		}
	default:{
			assert(0);	/* should never get here */
		}
	}
	datum->s.value = value;

	bool_value = (char *)queue_remove(id_queue);
	if (!bool_value) {
		yyerror("no default value for bool definition?");
		free(id);
		return -1;
	}

	datum->state = (int)(bool_value[0] == 'T') ? 1 : 0;
	return 0;
      cleanup:
	cond_destroy_bool(id, datum, NULL);
	return -1;
}

static avrule_t *define_cond_pol_list(avrule_t * avlist, avrule_t * sl)
{
	if (pass == 1) {
		/* return something so we get through pass 1 */
		return (avrule_t *) 1;
	}

	if (sl == NULL) {
		/* This is a require block, return previous list */
		return avlist;
	}

	/* prepend the new avlist to the pre-existing one */
	sl->next = avlist;
	return sl;
}

static int define_te_avtab_helper(int which, avrule_t ** rule)
{
	char *id;
	class_datum_t *cladatum;
	perm_datum_t *perdatum = NULL;
	class_perm_node_t *perms, *tail = NULL, *cur_perms = NULL;
	ebitmap_t tclasses;
	ebitmap_node_t *node;
	avrule_t *avrule;
	unsigned int i;
	int add = 1, ret = 0;
	int suppress = 0;

	avrule = (avrule_t *) malloc(sizeof(avrule_t));
	if (!avrule) {
		yyerror("memory error");
		ret = -1;
		goto out;
	}
	avrule_init(avrule);
	avrule->specified = which;
	avrule->line = policydb_lineno;

	while ((id = queue_remove(id_queue))) {
		if (set_types
		    (&avrule->stypes, id, &add,
		     which == AVRULE_NEVERALLOW ? 1 : 0)) {
			ret = -1;
			goto out;
		}
	}
	add = 1;
	while ((id = queue_remove(id_queue))) {
		if (strcmp(id, "self") == 0) {
			free(id);
			avrule->flags |= RULE_SELF;
			continue;
		}
		if (set_types
		    (&avrule->ttypes, id, &add,
		     which == AVRULE_NEVERALLOW ? 1 : 0)) {
			ret = -1;
			goto out;
		}
	}

	ebitmap_init(&tclasses);
	while ((id = queue_remove(id_queue))) {
		if (!is_id_in_scope(SYM_CLASSES, id)) {
			yyerror2("class %s is not within scope", id);
			ret = -1;
			goto out;
		}
		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) {
			sprintf(errormsg, "unknown class %s used in rule", id);
			yyerror(errormsg);
			ret = -1;
			goto out;
		}
		if (ebitmap_set_bit(&tclasses, cladatum->s.value - 1, TRUE)) {
			yyerror("Out of memory");
			ret = -1;
			goto out;
		}
		free(id);
	}

	perms = NULL;
	ebitmap_for_each_bit(&tclasses, node, i) {
		if (!ebitmap_node_get_bit(node, i))
			continue;
		cur_perms =
		    (class_perm_node_t *) malloc(sizeof(class_perm_node_t));
		if (!cur_perms) {
			yyerror("out of memory");
			ret = -1;
			goto out;
		}
		class_perm_node_init(cur_perms);
		cur_perms->class = i + 1;
		if (!perms)
			perms = cur_perms;
		if (tail)
			tail->next = cur_perms;
		tail = cur_perms;
	}

	while ((id = queue_remove(id_queue))) {
		cur_perms = perms;
		ebitmap_for_each_bit(&tclasses, node, i) {
			if (!ebitmap_node_get_bit(node, i))
				continue;
			cladatum = policydbp->class_val_to_struct[i];

			if (strcmp(id, "*") == 0) {
				/* set all permissions in the class */
				cur_perms->data = ~0U;
				goto next;
			}

			if (strcmp(id, "~") == 0) {
				/* complement the set */
				if (which == AVRULE_DONTAUDIT)
					yywarn("dontaudit rule with a ~?");
				cur_perms->data = ~cur_perms->data;
				goto next;
			}

			perdatum =
			    hashtab_search(cladatum->permissions.table, id);
			if (!perdatum) {
				if (cladatum->comdatum) {
					perdatum =
					    hashtab_search(cladatum->comdatum->
							   permissions.table,
							   id);
				}
			}
			if (!perdatum) {
				sprintf(errormsg,
					"permission %s is not defined for class %s",
					id, policydbp->p_class_val_to_name[i]);
				if (!suppress)
					yyerror(errormsg);
				continue;
			} else
			    if (!is_perm_in_scope
				(id, policydbp->p_class_val_to_name[i])) {
				if (!suppress) {
					yyerror2
					    ("permission %s of class %s is not within scope",
					     id,
					     policydbp->p_class_val_to_name[i]);
				}
				continue;
			} else {
				cur_perms->data |= 1U << (perdatum->s.value - 1);
			}
		      next:
			cur_perms = cur_perms->next;
		}

		free(id);
	}

	ebitmap_destroy(&tclasses);

	avrule->perms = perms;
	*rule = avrule;

      out:
	return ret;

}

static avrule_t *define_cond_te_avtab(int which)
{
	char *id;
	avrule_t *avrule;
	int i;

	if (pass == 1) {
		for (i = 0; i < 4; i++) {
			while ((id = queue_remove(id_queue)))
				free(id);
		}
		return (avrule_t *) 1;	/* any non-NULL value */
	}

	if (define_te_avtab_helper(which, &avrule))
		return COND_ERR;

	return avrule;
}

static int define_te_avtab(int which)
{
	char *id;
	avrule_t *avrule;
	int i;

	if (pass == 1) {
		for (i = 0; i < 4; i++) {
			while ((id = queue_remove(id_queue)))
				free(id);
		}
		return 0;
	}

	if (define_te_avtab_helper(which, &avrule))
		return -1;

	/* append this avrule to the end of the current rules list */
	append_avrule(avrule);
	return 0;
}

static int define_role_types(void)
{
	role_datum_t *role;
	char *id;
	int add = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	if ((role = declare_role()) == NULL) {
		return -1;
	}
	while ((id = queue_remove(id_queue))) {
		if (set_types(&role->types, id, &add, 0))
			return -1;
	}

	return 0;
}

static role_datum_t *merge_roles_dom(role_datum_t * r1, role_datum_t * r2)
{
	role_datum_t *new;

	if (pass == 1) {
		return (role_datum_t *) 1;	/* any non-NULL value */
	}

	new = malloc(sizeof(role_datum_t));
	if (!new) {
		yyerror("out of memory");
		return NULL;
	}
	memset(new, 0, sizeof(role_datum_t));
	new->s.value = 0;		/* temporary role */
	if (ebitmap_or(&new->dominates, &r1->dominates, &r2->dominates)) {
		yyerror("out of memory");
		return NULL;
	}
	if (ebitmap_or(&new->types.types, &r1->types.types, &r2->types.types)) {
		yyerror("out of memory");
		return NULL;
	}
	if (!r1->s.value) {
		/* free intermediate result */
		type_set_destroy(&r1->types);
		ebitmap_destroy(&r1->dominates);
		free(r1);
	}
	if (!r2->s.value) {
		/* free intermediate result */
		yyerror("right hand role is temporary?");
		type_set_destroy(&r2->types);
		ebitmap_destroy(&r2->dominates);
		free(r2);
	}
	return new;
}

/* This function eliminates the ordering dependency of role dominance rule */
static int dominate_role_recheck(hashtab_key_t key, hashtab_datum_t datum,
				 void *arg)
{
	role_datum_t *rdp = (role_datum_t *) arg;
	role_datum_t *rdatum = (role_datum_t *) datum;
	ebitmap_node_t *node;
	int i;

	/* Don't bother to process against self role */
	if (rdatum->s.value == rdp->s.value)
		return 0;

	/* If a dominating role found */
	if (ebitmap_get_bit(&(rdatum->dominates), rdp->s.value - 1)) {
		ebitmap_t types;
		ebitmap_init(&types);
		if (type_set_expand(&rdp->types, &types, policydbp, 1)) {
			ebitmap_destroy(&types);
			return -1;
		}
		/* raise types and dominates from dominated role */
		ebitmap_for_each_bit(&rdp->dominates, node, i) {
			if (ebitmap_node_get_bit(node, i))
				if (ebitmap_set_bit
				    (&rdatum->dominates, i, TRUE))
					goto oom;
		}
		ebitmap_for_each_bit(&types, node, i) {
			if (ebitmap_node_get_bit(node, i))
				if (ebitmap_set_bit
				    (&rdatum->types.types, i, TRUE))
					goto oom;
		}
		ebitmap_destroy(&types);
	}

	/* go through all the roles */
	return 0;
      oom:
	yyerror("Out of memory");
	return -1;
}

static role_datum_t *define_role_dom(role_datum_t * r)
{
	role_datum_t *role;
	char *role_id;
	ebitmap_node_t *node;
	unsigned int i;
	int ret;

	if (pass == 1) {
		role_id = queue_remove(id_queue);
		free(role_id);
		return (role_datum_t *) 1;	/* any non-NULL value */
	}

	role_id = queue_remove(id_queue);
	if (!is_id_in_scope(SYM_ROLES, role_id)) {
		yyerror2("role %s is not within scope", role_id);
		free(role_id);
		return NULL;
	}
	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       role_id);
	if (!role) {
		role = (role_datum_t *) malloc(sizeof(role_datum_t));
		if (!role) {
			yyerror("out of memory");
			free(role_id);
			return NULL;
		}
		memset(role, 0, sizeof(role_datum_t));
		ret =
		    declare_symbol(SYM_ROLES, (hashtab_key_t) role_id,
				   (hashtab_datum_t) role, &role->s.value,
				   &role->s.value);
		switch (ret) {
		case -3:{
				yyerror("Out of memory!");
				goto cleanup;
			}
		case -2:{
				yyerror2("duplicate declaration of role %s",
					 role_id);
				goto cleanup;
			}
		case -1:{
				yyerror("could not declare role here");
				goto cleanup;
			}
		case 0:
		case 1:{
				break;
			}
		default:{
				assert(0);	/* should never get here */
			}
		}
		if (ebitmap_set_bit(&role->dominates, role->s.value - 1, TRUE)) {
			yyerror("Out of memory!");
			goto cleanup;
		}
	}
	if (r) {
		ebitmap_t types;
		ebitmap_init(&types);
		ebitmap_for_each_bit(&r->dominates, node, i) {
			if (ebitmap_node_get_bit(node, i))
				if (ebitmap_set_bit(&role->dominates, i, TRUE))
					goto oom;
		}
		if (type_set_expand(&r->types, &types, policydbp, 1)) {
			ebitmap_destroy(&types);
			return NULL;
		}
		ebitmap_for_each_bit(&types, node, i) {
			if (ebitmap_node_get_bit(node, i))
				if (ebitmap_set_bit
				    (&role->types.types, i, TRUE))
					goto oom;
		}
		ebitmap_destroy(&types);
		if (!r->s.value) {
			/* free intermediate result */
			type_set_destroy(&r->types);
			ebitmap_destroy(&r->dominates);
			free(r);
		}
		/*
		 * Now go through all the roles and escalate this role's
		 * dominates and types if a role dominates this role.
		 */
		hashtab_map(policydbp->p_roles.table,
			    dominate_role_recheck, role);
	}
	return role;
      cleanup:
	free(role_id);
	role_datum_destroy(role);
	free(role);
	return NULL;
      oom:
	yyerror("Out of memory");
	goto cleanup;
}

static int role_val_to_name_helper(hashtab_key_t key, hashtab_datum_t datum,
				   void *p)
{
	struct val_to_name *v = p;
	role_datum_t *roldatum;

	roldatum = (role_datum_t *) datum;

	if (v->val == roldatum->s.value) {
		v->name = key;
		return 1;
	}

	return 0;
}

static char *role_val_to_name(unsigned int val)
{
	struct val_to_name v;
	int rc;

	v.val = val;
	rc = hashtab_map(policydbp->p_roles.table, role_val_to_name_helper, &v);
	if (rc)
		return v.name;
	return NULL;
}

static int set_roles(role_set_t * set, char *id)
{
	role_datum_t *r;

	if (strcmp(id, "*") == 0) {
		free(id);
		yyerror("* is not allowed for role sets");
		return -1;
	}

	if (strcmp(id, "~") == 0) {
		free(id);
		yyerror("~ is not allowed for role sets");
		return -1;
	}
	if (!is_id_in_scope(SYM_ROLES, id)) {
		yyerror2("role %s is not within scope", id);
		free(id);
		return -1;
	}
	r = hashtab_search(policydbp->p_roles.table, id);
	if (!r) {
		yyerror2("unknown role %s", id);
		free(id);
		return -1;
	}

	if (ebitmap_set_bit(&set->roles, r->s.value - 1, TRUE)) {
		yyerror("out of memory");
		free(id);
		return -1;
	}
	free(id);
	return 0;
}

static int define_role_trans(void)
{
	char *id;
	role_datum_t *role;
	role_set_t roles;
	type_set_t types;
	ebitmap_t e_types, e_roles;
	ebitmap_node_t *tnode, *rnode;
	struct role_trans *tr = NULL;
	struct role_trans_rule *rule = NULL;
	unsigned int i, j;
	int add = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	role_set_init(&roles);
	ebitmap_init(&e_roles);
	type_set_init(&types);
	ebitmap_init(&e_types);

	while ((id = queue_remove(id_queue))) {
		if (set_roles(&roles, id))
			return -1;
	}
	add = 1;
	while ((id = queue_remove(id_queue))) {
		if (set_types(&types, id, &add, 0))
			return -1;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no new role in transition definition?");
		goto bad;
	}
	if (!is_id_in_scope(SYM_ROLES, id)) {
		yyerror2("role %s is not within scope", id);
		free(id);
		goto bad;
	}
	role = hashtab_search(policydbp->p_roles.table, id);
	if (!role) {
		sprintf(errormsg,
			"unknown role %s used in transition definition", id);
		yyerror(errormsg);
		goto bad;
	}

	/* This ebitmap business is just to ensure that there are not conflicting role_trans rules */
	if (role_set_expand(&roles, &e_roles, policydbp))
		goto bad;

	if (type_set_expand(&types, &e_types, policydbp, 1))
		goto bad;

	ebitmap_for_each_bit(&e_roles, rnode, i) {
		if (!ebitmap_node_get_bit(rnode, i))
			continue;
		ebitmap_for_each_bit(&e_types, tnode, j) {
			if (!ebitmap_node_get_bit(tnode, j))
				continue;

			for (tr = policydbp->role_tr; tr; tr = tr->next) {
				if (tr->role == (i + 1) && tr->type == (j + 1)) {
					sprintf(errormsg,
						"duplicate role transition for (%s,%s)",
						role_val_to_name(i + 1),
						policydbp->
						p_type_val_to_name[j]);
					yyerror(errormsg);
					goto bad;
				}
			}

			tr = malloc(sizeof(struct role_trans));
			if (!tr) {
				yyerror("out of memory");
				return -1;
			}
			memset(tr, 0, sizeof(struct role_trans));
			tr->role = i + 1;
			tr->type = j + 1;
			tr->new_role = role->s.value;
			tr->next = policydbp->role_tr;
			policydbp->role_tr = tr;
		}
	}
	/* Now add the real rule */
	rule = malloc(sizeof(struct role_trans_rule));
	if (!rule) {
		yyerror("out of memory");
		return -1;
	}
	memset(rule, 0, sizeof(struct role_trans_rule));
	rule->roles = roles;
	rule->types = types;
	rule->new_role = role->s.value;

	append_role_trans(rule);

	ebitmap_destroy(&e_roles);
	ebitmap_destroy(&e_types);

	return 0;

      bad:
	return -1;
}

static int define_role_allow(void)
{
	char *id;
	struct role_allow_rule *ra = 0;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	ra = malloc(sizeof(role_allow_rule_t));
	if (!ra) {
		yyerror("out of memory");
		return -1;
	}
	role_allow_rule_init(ra);

	while ((id = queue_remove(id_queue))) {
		if (set_roles(&ra->roles, id))
			return -1;
	}

	while ((id = queue_remove(id_queue))) {
		if (set_roles(&ra->new_roles, id))
			return -1;
	}

	append_role_allow(ra);
	return 0;
}

static constraint_expr_t *constraint_expr_clone(constraint_expr_t * expr)
{
	constraint_expr_t *h = NULL, *l = NULL, *e, *newe;
	for (e = expr; e; e = e->next) {
		newe = malloc(sizeof(*newe));
		if (!newe)
			goto oom;
		if (constraint_expr_init(newe) == -1) {
			free(newe);
			goto oom;
		}
		if (l)
			l->next = newe;
		else
			h = newe;
		l = newe;
		newe->expr_type = e->expr_type;
		newe->attr = e->attr;
		newe->op = e->op;
		if (newe->expr_type == CEXPR_NAMES) {
			if (newe->attr & CEXPR_TYPE) {
				if (type_set_cpy
				    (newe->type_names, e->type_names))
					goto oom;
			} else {
				if (ebitmap_cpy(&newe->names, &e->names))
					goto oom;
			}
		}
	}

	return h;
      oom:
	e = h;
	while (e) {
		l = e;
		e = e->next;
		constraint_expr_destroy(l);
	}
	return NULL;
}

static int define_constraint(constraint_expr_t * expr)
{
	struct constraint_node *node;
	char *id;
	class_datum_t *cladatum;
	perm_datum_t *perdatum;
	ebitmap_t classmap;
	ebitmap_node_t *enode;
	constraint_expr_t *e;
	unsigned int i;
	int depth;
	unsigned char useexpr = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case CEXPR_NOT:
			if (depth < 0) {
				yyerror("illegal constraint expression");
				return -1;
			}
			break;
		case CEXPR_AND:
		case CEXPR_OR:
			if (depth < 1) {
				yyerror("illegal constraint expression");
				return -1;
			}
			depth--;
			break;
		case CEXPR_ATTR:
		case CEXPR_NAMES:
			if (e->attr & CEXPR_XTARGET) {
				yyerror("illegal constraint expression");
				return -1;	/* only for validatetrans rules */
			}
			if (depth == (CEXPR_MAXDEPTH - 1)) {
				yyerror("constraint expression is too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal constraint expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal constraint expression");
		return -1;
	}

	ebitmap_init(&classmap);
	while ((id = queue_remove(id_queue))) {
		if (!is_id_in_scope(SYM_CLASSES, id)) {
			yyerror2("class %s is not within scope", id);
			free(id);
			return -1;
		}
		cladatum =
		    (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						     (hashtab_key_t) id);
		if (!cladatum) {
			sprintf(errormsg, "class %s is not defined", id);
			ebitmap_destroy(&classmap);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (ebitmap_set_bit(&classmap, cladatum->s.value - 1, TRUE)) {
			yyerror("out of memory");
			ebitmap_destroy(&classmap);
			free(id);
			return -1;
		}
		node = malloc(sizeof(struct constraint_node));
		if (!node) {
			yyerror("out of memory");
			return -1;
		}
		memset(node, 0, sizeof(constraint_node_t));
		if (useexpr) {
			node->expr = expr;
			useexpr = 0;
		} else {
			node->expr = constraint_expr_clone(expr);
		}
		if (!node->expr) {
			yyerror("out of memory");
			return -1;
		}
		node->permissions = 0;

		node->next = cladatum->constraints;
		cladatum->constraints = node;

		free(id);
	}

	while ((id = queue_remove(id_queue))) {
		ebitmap_for_each_bit(&classmap, enode, i) {
			if (ebitmap_node_get_bit(enode, i)) {
				cladatum = policydbp->class_val_to_struct[i];
				node = cladatum->constraints;

				perdatum =
				    (perm_datum_t *) hashtab_search(cladatum->
								    permissions.
								    table,
								    (hashtab_key_t)
								    id);
				if (!perdatum) {
					if (cladatum->comdatum) {
						perdatum =
						    (perm_datum_t *)
						    hashtab_search(cladatum->
								   comdatum->
								   permissions.
								   table,
								   (hashtab_key_t)
								   id);
					}
					if (!perdatum) {
						sprintf(errormsg,
							"permission %s is not defined",
							id);
						yyerror(errormsg);
						free(id);
						ebitmap_destroy(&classmap);
						return -1;
					}
				}
				node->permissions |=
				    (1 << (perdatum->s.value - 1));
			}
		}
		free(id);
	}

	ebitmap_destroy(&classmap);

	return 0;
}

static int define_validatetrans(constraint_expr_t * expr)
{
	struct constraint_node *node;
	char *id;
	class_datum_t *cladatum;
	ebitmap_t classmap;
	constraint_expr_t *e;
	int depth;
	unsigned char useexpr = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case CEXPR_NOT:
			if (depth < 0) {
				yyerror("illegal validatetrans expression");
				return -1;
			}
			break;
		case CEXPR_AND:
		case CEXPR_OR:
			if (depth < 1) {
				yyerror("illegal validatetrans expression");
				return -1;
			}
			depth--;
			break;
		case CEXPR_ATTR:
		case CEXPR_NAMES:
			if (depth == (CEXPR_MAXDEPTH - 1)) {
				yyerror("validatetrans expression is too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal validatetrans expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal validatetrans expression");
		return -1;
	}

	ebitmap_init(&classmap);
	while ((id = queue_remove(id_queue))) {
		if (!is_id_in_scope(SYM_CLASSES, id)) {
			yyerror2("class %s is not within scope", id);
			free(id);
			return -1;
		}
		cladatum =
		    (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						     (hashtab_key_t) id);
		if (!cladatum) {
			sprintf(errormsg, "class %s is not defined", id);
			ebitmap_destroy(&classmap);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (ebitmap_set_bit(&classmap, (cladatum->s.value - 1), TRUE)) {
			yyerror("out of memory");
			ebitmap_destroy(&classmap);
			free(id);
			return -1;
		}

		node = malloc(sizeof(struct constraint_node));
		if (!node) {
			yyerror("out of memory");
			return -1;
		}
		memset(node, 0, sizeof(constraint_node_t));
		if (useexpr) {
			node->expr = expr;
			useexpr = 0;
		} else {
			node->expr = constraint_expr_clone(expr);
		}
		node->permissions = 0;

		node->next = cladatum->validatetrans;
		cladatum->validatetrans = node;

		free(id);
	}

	ebitmap_destroy(&classmap);

	return 0;
}

static uintptr_t
define_cexpr(uint32_t expr_type, uintptr_t arg1, uintptr_t arg2)
{
	struct constraint_expr *expr, *e1 = NULL, *e2;
	user_datum_t *user;
	role_datum_t *role;
	ebitmap_t negset;
	char *id;
	uint32_t val;
	int add = 1;

	if (pass == 1) {
		if (expr_type == CEXPR_NAMES) {
			while ((id = queue_remove(id_queue)))
				free(id);
		}
		return 1;	/* any non-NULL value */
	}

	if ((expr = malloc(sizeof(*expr))) == NULL ||
	    constraint_expr_init(expr) == -1) {
		yyerror("out of memory");
		free(expr);
		return 0;
	}
	expr->expr_type = expr_type;

	switch (expr_type) {
	case CEXPR_NOT:
		e1 = NULL;
		e2 = (struct constraint_expr *)arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
			constraint_expr_destroy(expr);
			return 0;
		}
		e1->next = expr;
		return arg1;
	case CEXPR_AND:
	case CEXPR_OR:
		e1 = NULL;
		e2 = (struct constraint_expr *)arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
			constraint_expr_destroy(expr);
			return 0;
		}
		e1->next = (struct constraint_expr *)arg2;

		e1 = NULL;
		e2 = (struct constraint_expr *)arg2;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
			constraint_expr_destroy(expr);
			return 0;
		}
		e1->next = expr;
		return arg1;
	case CEXPR_ATTR:
		expr->attr = arg1;
		expr->op = arg2;
		return (uintptr_t) expr;
	case CEXPR_NAMES:
		add = 1;
		expr->attr = arg1;
		expr->op = arg2;
		ebitmap_init(&negset);
		while ((id = (char *)queue_remove(id_queue))) {
			if (expr->attr & CEXPR_USER) {
				if (!is_id_in_scope(SYM_USERS, id)) {
					yyerror2("user %s is not within scope",
						 id);
					constraint_expr_destroy(expr);
					return 0;
				}
				user =
				    (user_datum_t *) hashtab_search(policydbp->
								    p_users.
								    table,
								    (hashtab_key_t)
								    id);
				if (!user) {
					sprintf(errormsg, "unknown user %s",
						id);
					yyerror(errormsg);
					constraint_expr_destroy(expr);
					return 0;
				}
				val = user->s.value;
			} else if (expr->attr & CEXPR_ROLE) {
				if (!is_id_in_scope(SYM_ROLES, id)) {
					yyerror2("role %s is not within scope",
						 id);
					constraint_expr_destroy(expr);
					return 0;
				}
				role =
				    (role_datum_t *) hashtab_search(policydbp->
								    p_roles.
								    table,
								    (hashtab_key_t)
								    id);
				if (!role) {
					sprintf(errormsg, "unknown role %s",
						id);
					yyerror(errormsg);
					constraint_expr_destroy(expr);
					return 0;
				}
				val = role->s.value;
			} else if (expr->attr & CEXPR_TYPE) {
				if (set_types(expr->type_names, id, &add, 0)) {
					constraint_expr_destroy(expr);
					return 0;
				}
				continue;
			} else {
				yyerror("invalid constraint expression");
				constraint_expr_destroy(expr);
				return 0;
			}
			if (ebitmap_set_bit(&expr->names, val - 1, TRUE)) {
				yyerror("out of memory");
				ebitmap_destroy(&expr->names);
				constraint_expr_destroy(expr);
				return 0;
			}
			free(id);
		}
		ebitmap_destroy(&negset);
		return (uintptr_t) expr;
	default:
		yyerror("invalid constraint expression");
		constraint_expr_destroy(expr);
		return 0;
	}

	yyerror("invalid constraint expression");
	free(expr);
	return 0;
}

static int define_conditional(cond_expr_t * expr, avrule_t * t, avrule_t * f)
{
	cond_expr_t *e;
	int depth;
	cond_node_t cn, *cn_old;

	/* expression cannot be NULL */
	if (!expr) {
		yyerror("illegal conditional expression");
		return -1;
	}
	if (!t) {
		if (!f) {
			/* empty is fine, destroy expression and return */
			cond_expr_destroy(expr);
			return 0;
		}
		/* Invert */
		t = f;
		f = 0;
		expr = define_cond_expr(COND_NOT, expr, 0);
		if (!expr) {
			yyerror("unable to invert");
			return -1;
		}
	}

	/* verify expression */
	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case COND_NOT:
			if (depth < 0) {
				yyerror
				    ("illegal conditional expression; Bad NOT");
				return -1;
			}
			break;
		case COND_AND:
		case COND_OR:
		case COND_XOR:
		case COND_EQ:
		case COND_NEQ:
			if (depth < 1) {
				yyerror
				    ("illegal conditional expression; Bad binary op");
				return -1;
			}
			depth--;
			break;
		case COND_BOOL:
			if (depth == (COND_EXPR_MAXDEPTH - 1)) {
				yyerror
				    ("conditional expression is like totally too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal conditional expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal conditional expression");
		return -1;
	}

	/*  use tmp conditional node to partially build new node */
	memset(&cn, 0, sizeof(cn));
	cn.expr = expr;
	cn.avtrue_list = t;
	cn.avfalse_list = f;

	/* normalize/precompute expression */
	if (cond_normalize_expr(policydbp, &cn) < 0) {
		yyerror("problem normalizing conditional expression");
		return -1;
	}

	/* get the existing conditional node, or create a new one */
	cn_old = get_current_cond_list(&cn);
	if (!cn_old) {
		return -1;
	}

	append_cond_list(&cn);

	/* note that there is no check here for duplicate rules, nor
	 * check that rule already exists in base -- that will be
	 * handled during conditional expansion, in expand.c */

	cn.avtrue_list = NULL;
	cn.avfalse_list = NULL;
	cond_node_destroy(&cn);

	return 0;
}

static cond_expr_t *define_cond_expr(uint32_t expr_type, void *arg1, void *arg2)
{
	struct cond_expr *expr, *e1 = NULL, *e2;
	cond_bool_datum_t *bool_var;
	char *id;

	/* expressions are handled in the second pass */
	if (pass == 1) {
		if (expr_type == COND_BOOL) {
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
		}
		return (cond_expr_t *) 1;	/* any non-NULL value */
	}

	/* create a new expression struct */
	expr = malloc(sizeof(struct cond_expr));
	if (!expr) {
		yyerror("out of memory");
		return NULL;
	}
	memset(expr, 0, sizeof(cond_expr_t));
	expr->expr_type = expr_type;

	/* create the type asked for */
	switch (expr_type) {
	case COND_NOT:
		e1 = NULL;
		e2 = (struct cond_expr *)arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal conditional NOT expression");
			free(expr);
			return NULL;
		}
		e1->next = expr;
		return (struct cond_expr *)arg1;
	case COND_AND:
	case COND_OR:
	case COND_XOR:
	case COND_EQ:
	case COND_NEQ:
		e1 = NULL;
		e2 = (struct cond_expr *)arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror
			    ("illegal left side of conditional binary op expression");
			free(expr);
			return NULL;
		}
		e1->next = (struct cond_expr *)arg2;

		e1 = NULL;
		e2 = (struct cond_expr *)arg2;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror
			    ("illegal right side of conditional binary op expression");
			free(expr);
			return NULL;
		}
		e1->next = expr;
		return (struct cond_expr *)arg1;
	case COND_BOOL:
		id = (char *)queue_remove(id_queue);
		if (!id) {
			yyerror("bad conditional; expected boolean id");
			free(id);
			free(expr);
			return NULL;
		}
		if (!is_id_in_scope(SYM_BOOLS, id)) {
			yyerror2("boolean %s is not within scope", id);
			free(id);
			free(expr);
			return NULL;
		}
		bool_var =
		    (cond_bool_datum_t *) hashtab_search(policydbp->p_bools.
							 table,
							 (hashtab_key_t) id);
		if (!bool_var) {
			sprintf(errormsg,
				"unknown boolean %s in conditional expression",
				id);
			yyerror(errormsg);
			free(expr);
			free(id);
			return NULL;
		}
		expr->bool = bool_var->s.value;
		free(id);
		return expr;
	default:
		yyerror("illegal conditional expression");
		return NULL;
	}
}

static int set_user_roles(role_set_t * set, char *id)
{
	role_datum_t *r;
	unsigned int i;
	ebitmap_node_t *node;

	if (strcmp(id, "*") == 0) {
		free(id);
		yyerror("* is not allowed in user declarations");
		return -1;
	}

	if (strcmp(id, "~") == 0) {
		free(id);
		yyerror("~ is not allowed in user declarations");
		return -1;
	}

	if (!is_id_in_scope(SYM_ROLES, id)) {
		yyerror2("role %s is not within scope", id);
		free(id);
		return -1;
	}
	r = hashtab_search(policydbp->p_roles.table, id);
	if (!r) {
		sprintf(errormsg, "unknown role %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	/* set the role and every role it dominates */
	ebitmap_for_each_bit(&r->dominates, node, i) {
		if (ebitmap_node_get_bit(node, i))
			if (ebitmap_set_bit(&set->roles, i, TRUE))
				goto oom;
	}
	free(id);
	return 0;
      oom:
	yyerror("out of memory");
	return -1;
}

static int
parse_categories(char *id, level_datum_t * levdatum, ebitmap_t * cats)
{
	cat_datum_t *cdatum;
	int range_start, range_end, i;

	if (id_has_dot(id)) {
		char *id_start = id;
		char *id_end = strchr(id, '.');

		*(id_end++) = '\0';

		cdatum = (cat_datum_t *) hashtab_search(policydbp->p_cats.table,
							(hashtab_key_t)
							id_start);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id_start);
			yyerror(errormsg);
			return -1;
		}
		range_start = cdatum->s.value - 1;
		cdatum = (cat_datum_t *) hashtab_search(policydbp->p_cats.table,
							(hashtab_key_t) id_end);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id_end);
			yyerror(errormsg);
			return -1;
		}
		range_end = cdatum->s.value - 1;

		if (range_end < range_start) {
			sprintf(errormsg, "category range is invalid");
			yyerror(errormsg);
			return -1;
		}
	} else {
		cdatum = (cat_datum_t *) hashtab_search(policydbp->p_cats.table,
							(hashtab_key_t) id);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id);
			yyerror(errormsg);
			return -1;
		}
		range_start = range_end = cdatum->s.value - 1;
	}

	for (i = range_start; i <= range_end; i++) {
		if (!ebitmap_get_bit(&levdatum->level->cat, i)) {
			uint32_t level_value = levdatum->level->sens - 1;
			policydb_index_others(NULL, policydbp, 0);
			sprintf(errormsg, "category %s can not be associated "
				"with level %s",
				policydbp->p_cat_val_to_name[i],
				policydbp->p_sens_val_to_name[level_value]);
			yyerror(errormsg);
			return -1;
		}
		if (ebitmap_set_bit(cats, i, TRUE)) {
			yyerror("out of memory");
			return -1;
		}
	}

	return 0;
}

static int
parse_semantic_categories(char *id, level_datum_t * levdatum,
                          mls_semantic_cat_t ** cats)
{
	cat_datum_t *cdatum;
	mls_semantic_cat_t *newcat;
	unsigned int range_start, range_end;

	if (id_has_dot(id)) {
		char *id_start = id;
		char *id_end = strchr(id, '.');

		*(id_end++) = '\0';

		cdatum = (cat_datum_t *) hashtab_search(policydbp->p_cats.table,
							(hashtab_key_t)
							id_start);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id_start);
			yyerror(errormsg);
			return -1;
		}
		range_start = cdatum->s.value;

		cdatum = (cat_datum_t *) hashtab_search(policydbp->p_cats.table,
							(hashtab_key_t) id_end);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id_end);
			yyerror(errormsg);
			return -1;
		}
		range_end = cdatum->s.value;
	} else {
		cdatum = (cat_datum_t *) hashtab_search(policydbp->p_cats.table,
							(hashtab_key_t) id);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id);
			yyerror(errormsg);
			return -1;
		}
		range_start = range_end = cdatum->s.value;
	}

	newcat = (mls_semantic_cat_t *) malloc(sizeof(mls_semantic_cat_t));
	if (!newcat) {
		yyerror("out of memory");
		return -1;
	}

	mls_semantic_cat_init(newcat);
	newcat->next = *cats;
	newcat->low = range_start;
	newcat->high = range_end;

	*cats = newcat;

	return 0;
}

static int define_user(void)
{
	char *id;
	user_datum_t *usrdatum;
	level_datum_t *levdatum;
	int l;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		if (mlspol) {
			while ((id = queue_remove(id_queue)))
				free(id);
			id = queue_remove(id_queue);
			free(id);
			for (l = 0; l < 2; l++) {
				while ((id = queue_remove(id_queue))) {
					free(id);
				}
				id = queue_remove(id_queue);
				if (!id)
					break;
				free(id);
			}
		}
		return 0;
	}

	if ((usrdatum = declare_user()) == NULL) {
		return -1;
	}

	while ((id = queue_remove(id_queue))) {
		if (set_user_roles(&usrdatum->roles, id))
			continue;
	}

	if (mlspol) {
		id = queue_remove(id_queue);
		if (!id) {
			yyerror("no default level specified for user");
			return -1;
		}

		levdatum = (level_datum_t *)
		    hashtab_search(policydbp->p_levels.table,
				   (hashtab_key_t) id);
		if (!levdatum) {
			sprintf(errormsg, "unknown sensitivity %s used in user"
				" level definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		free(id);

		usrdatum->dfltlevel.sens = levdatum->level->sens;

		while ((id = queue_remove(id_queue))) {
			if (parse_semantic_categories(id, levdatum,
			                            &usrdatum->dfltlevel.cat)) {
				free(id);
				return -1;
			}
			free(id);
		}

		id = queue_remove(id_queue);

		for (l = 0; l < 2; l++) {
			levdatum = (level_datum_t *)
			    hashtab_search(policydbp->p_levels.table,
					   (hashtab_key_t) id);
			if (!levdatum) {
				sprintf(errormsg,
					"unknown sensitivity %s used in user range definition",
					id);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			free(id);

			usrdatum->range.level[l].sens = levdatum->level->sens;

			while ((id = queue_remove(id_queue))) {
				if (parse_semantic_categories(id, levdatum,
				               &usrdatum->range.level[l].cat)) {
					free(id);
					return -1;
				}
				free(id);
			}

			id = queue_remove(id_queue);
			if (!id)
				break;
		}

		if (l == 0) {
			if (mls_semantic_level_cpy(&usrdatum->range.level[1],
			                           &usrdatum->range.level[0])) {
				yyerror("out of memory");
				return -1;
			}
		}
	}
	return 0;
}

static int parse_security_context(context_struct_t * c)
{
	char *id;
	role_datum_t *role;
	type_datum_t *typdatum;
	user_datum_t *usrdatum;
	level_datum_t *levdatum;
	int l;

	if (pass == 1) {
		id = queue_remove(id_queue);
		free(id);	/* user  */
		id = queue_remove(id_queue);
		free(id);	/* role  */
		id = queue_remove(id_queue);
		free(id);	/* type  */
		if (mlspol) {
			id = queue_remove(id_queue);
			free(id);
			for (l = 0; l < 2; l++) {
				while ((id = queue_remove(id_queue))) {
					free(id);
				}
				id = queue_remove(id_queue);
				if (!id)
					break;
				free(id);
			}
		}
		return 0;
	}

	context_init(c);

	/* extract the user */
	id = queue_remove(id_queue);
	if (!id) {
		yyerror("no effective user?");
		goto bad;
	}
	if (!is_id_in_scope(SYM_USERS, id)) {
		yyerror2("user %s is not within scope", id);
		free(id);
		goto bad;
	}
	usrdatum = (user_datum_t *) hashtab_search(policydbp->p_users.table,
						   (hashtab_key_t) id);
	if (!usrdatum) {
		sprintf(errormsg, "user %s is not defined", id);
		yyerror(errormsg);
		free(id);
		goto bad;
	}
	c->user = usrdatum->s.value;

	/* no need to keep the user name */
	free(id);

	/* extract the role */
	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no role name for sid context definition?");
		return -1;
	}
	if (!is_id_in_scope(SYM_ROLES, id)) {
		yyerror2("role %s is not within scope", id);
		free(id);
		return -1;
	}
	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       (hashtab_key_t) id);
	if (!role) {
		sprintf(errormsg, "role %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	c->role = role->s.value;

	/* no need to keep the role name */
	free(id);

	/* extract the type */
	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for sid context definition?");
		return -1;
	}
	if (!is_id_in_scope(SYM_TYPES, id)) {
		yyerror2("type %s is not within scope", id);
		free(id);
		return -1;
	}
	typdatum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						   (hashtab_key_t) id);
	if (!typdatum || typdatum->flavor == TYPE_ATTRIB) {
		sprintf(errormsg, "type %s is not defined or is an attribute",
			id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	c->type = typdatum->s.value;

	/* no need to keep the type name */
	free(id);

	if (mlspol) {
		/* extract the low sensitivity */
		id = (char *)queue_head(id_queue);
		if (!id) {
			yyerror("no sensitivity name for sid context"
				" definition?");
			return -1;
		}

		id = (char *)queue_remove(id_queue);
		for (l = 0; l < 2; l++) {
			levdatum = (level_datum_t *)
			    hashtab_search(policydbp->p_levels.table,
					   (hashtab_key_t) id);
			if (!levdatum) {
				sprintf(errormsg, "Sensitivity %s is not "
					"defined", id);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			free(id);
			c->range.level[l].sens = levdatum->level->sens;

			/* extract low category set */
			while ((id = queue_remove(id_queue))) {
				if (parse_categories(id, levdatum,
						     &c->range.level[l].cat)) {
					free(id);
					return -1;
				}
				free(id);
			}

			/* extract high sensitivity */
			id = (char *)queue_remove(id_queue);
			if (!id)
				break;
		}

		if (l == 0) {
			c->range.level[1].sens = c->range.level[0].sens;
			if (ebitmap_cpy(&c->range.level[1].cat,
					&c->range.level[0].cat)) {

				yyerror("out of memory");
				goto bad;
			}
		}
	}

	if (!policydb_context_isvalid(policydbp, c)) {
		yyerror("invalid security context");
		goto bad;
	}
	return 0;

      bad:
	context_destroy(c);

	return -1;
}

static int define_initial_sid_context(void)
{
	char *id;
	ocontext_t *c, *head;

	if (pass == 1) {
		id = (char *)queue_remove(id_queue);
		free(id);
		parse_security_context(NULL);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no sid name for SID context definition?");
		return -1;
	}
	head = policydbp->ocontexts[OCON_ISID];
	for (c = head; c; c = c->next) {
		if (!strcmp(id, c->u.name))
			break;
	}

	if (!c) {
		sprintf(errormsg, "SID %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (c->context[0].user) {
		sprintf(errormsg, "The context for SID %s is multiply defined",
			id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	/* no need to keep the sid name */
	free(id);

	if (parse_security_context(&c->context[0]))
		return -1;

	return 0;
}

static int define_fs_context(unsigned int major, unsigned int minor)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		parse_security_context(NULL);
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *)malloc(6);
	if (!newc->u.name) {
		yyerror("out of memory");
		free(newc);
		return -1;
	}
	sprintf(newc->u.name, "%02x:%02x", major, minor);

	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[1])) {
		context_destroy(&newc->context[0]);
		free(newc->u.name);
		free(newc);
		return -1;
	}
	head = policydbp->ocontexts[OCON_FS];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate entry for file system %s",
				newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			context_destroy(&newc->context[1]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_FS] = newc;

	return 0;
}

static int define_port_context(unsigned int low, unsigned int high)
{
	ocontext_t *newc, *c, *l, *head;
	unsigned int protocol;
	char *id;

	if (pass == 1) {
		id = (char *)queue_remove(id_queue);
		free(id);
		parse_security_context(NULL);
		return 0;
	}

	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	id = (char *)queue_remove(id_queue);
	if (!id) {
		free(newc);
		return -1;
	}
	if ((strcmp(id, "tcp") == 0) || (strcmp(id, "TCP") == 0)) {
		protocol = IPPROTO_TCP;
	} else if ((strcmp(id, "udp") == 0) || (strcmp(id, "UDP") == 0)) {
		protocol = IPPROTO_UDP;
	} else {
		sprintf(errormsg, "unrecognized protocol %s", id);
		yyerror(errormsg);
		free(newc);
		return -1;
	}

	newc->u.port.protocol = protocol;
	newc->u.port.low_port = low;
	newc->u.port.high_port = high;

	if (low > high) {
		sprintf(errormsg, "low port %d exceeds high port %d", low,
			high);
		yyerror(errormsg);
		free(newc);
		return -1;
	}

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		return -1;
	}

	/* Preserve the matching order specified in the configuration. */
	head = policydbp->ocontexts[OCON_PORT];
	for (l = NULL, c = head; c; l = c, c = c->next) {
		unsigned int prot2, low2, high2;

		prot2 = c->u.port.protocol;
		low2 = c->u.port.low_port;
		high2 = c->u.port.high_port;
		if (protocol != prot2)
			continue;
		if (low == low2 && high == high2) {
			sprintf(errormsg,
				"duplicate portcon entry for %s %d-%d ", id,
				low, high);
			goto bad;
		}
		if (low2 <= low && high2 >= high) {
			sprintf(errormsg,
				"portcon entry for %s %d-%d hidden by earlier entry for %d-%d",
				id, low, high, low2, high2);
			goto bad;
		}
	}

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_PORT] = newc;

	return 0;

      bad:
	yyerror(errormsg);
	free(newc);
	return -1;
}

static int define_netif_context(void)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *)queue_remove(id_queue);
	if (!newc->u.name) {
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[1])) {
		context_destroy(&newc->context[0]);
		free(newc->u.name);
		free(newc);
		return -1;
	}
	head = policydbp->ocontexts[OCON_NETIF];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg,
				"duplicate entry for network interface %s",
				newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			context_destroy(&newc->context[1]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_NETIF] = newc;
	return 0;
}

static int define_ipv4_node_context(unsigned int addr, unsigned int mask)
{
	ocontext_t *newc, *c, *l, *head;

	if (pass == 1) {
		parse_security_context(NULL);
		if (mlspol)
			free(queue_remove(id_queue));
		return 0;
	}

	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.node.addr = addr;
	newc->u.node.mask = mask;

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		return -1;
	}

	/* Create order of most specific to least retaining
	   the order specified in the configuration. */
	head = policydbp->ocontexts[OCON_NODE];
	for (l = NULL, c = head; c; l = c, c = c->next) {
		if (newc->u.node.mask > c->u.node.mask)
			break;
	}

	newc->next = c;

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_NODE] = newc;

	return 0;
}

static int define_ipv6_node_context(void)
{
	char *id;
	int rc = 0;
	struct in6_addr addr, mask;
	ocontext_t *newc, *c, *l, *head;

	if (pass == 1) {
		free(queue_remove(id_queue));
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		goto out;
	}

	id = queue_remove(id_queue);
	if (!id) {
		yyerror("failed to read ipv6 address");
		rc = -1;
		goto out;
	}

	rc = inet_pton(AF_INET6, id, &addr);
	free(id);
	if (rc < 1) {
		yyerror("failed to parse ipv6 address");
		if (rc == 0)
			rc = -1;
		goto out;
	}

	id = queue_remove(id_queue);
	if (!id) {
		yyerror("failed to read ipv6 address");
		rc = -1;
		goto out;
	}

	rc = inet_pton(AF_INET6, id, &mask);
	free(id);
	if (rc < 1) {
		yyerror("failed to parse ipv6 mask");
		if (rc == 0)
			rc = -1;
		goto out;
	}

	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		rc = -1;
		goto out;
	}

	memset(newc, 0, sizeof(ocontext_t));
	memcpy(&newc->u.node6.addr[0], &addr.s6_addr32[0], 16);
	memcpy(&newc->u.node6.mask[0], &mask.s6_addr32[0], 16);

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		rc = -1;
		goto out;
	}

	/* Create order of most specific to least retaining
	   the order specified in the configuration. */
	head = policydbp->ocontexts[OCON_NODE6];
	for (l = NULL, c = head; c; l = c, c = c->next) {
		if (memcmp(&newc->u.node6.mask, &c->u.node6.mask, 16) > 0)
			break;
	}

	newc->next = c;

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_NODE6] = newc;

	rc = 0;
      out:
	return rc;
}

static int define_fs_use(int behavior)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *)queue_remove(id_queue);
	if (!newc->u.name) {
		free(newc);
		return -1;
	}
	newc->v.behavior = behavior;
	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}

	head = policydbp->ocontexts[OCON_FSUSE];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg,
				"duplicate fs_use entry for filesystem type %s",
				newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_FSUSE] = newc;
	return 0;
}

static int define_genfs_context_helper(char *fstype, int has_type)
{
	struct genfs *genfs_p, *genfs, *newgenfs;
	ocontext_t *newc, *c, *head, *p;
	char *type = NULL;
	int len, len2;

	if (pass == 1) {
		free(fstype);
		free(queue_remove(id_queue));
		if (has_type)
			free(queue_remove(id_queue));
		parse_security_context(NULL);
		return 0;
	}

	for (genfs_p = NULL, genfs = policydbp->genfs;
	     genfs; genfs_p = genfs, genfs = genfs->next) {
		if (strcmp(fstype, genfs->fstype) <= 0)
			break;
	}

	if (!genfs || strcmp(fstype, genfs->fstype)) {
		newgenfs = malloc(sizeof(struct genfs));
		if (!newgenfs) {
			yyerror("out of memory");
			return -1;
		}
		memset(newgenfs, 0, sizeof(struct genfs));
		newgenfs->fstype = fstype;
		newgenfs->next = genfs;
		if (genfs_p)
			genfs_p->next = newgenfs;
		else
			policydbp->genfs = newgenfs;
		genfs = newgenfs;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *)queue_remove(id_queue);
	if (!newc->u.name)
		goto fail;
	if (has_type) {
		type = (char *)queue_remove(id_queue);
		if (!type)
			goto fail;
		if (type[1] != 0) {
			sprintf(errormsg, "invalid type %s", type);
			yyerror(errormsg);
			goto fail;
		}
		switch (type[0]) {
		case 'b':
			newc->v.sclass = SECCLASS_BLK_FILE;
			break;
		case 'c':
			newc->v.sclass = SECCLASS_CHR_FILE;
			break;
		case 'd':
			newc->v.sclass = SECCLASS_DIR;
			break;
		case 'p':
			newc->v.sclass = SECCLASS_FIFO_FILE;
			break;
		case 'l':
			newc->v.sclass = SECCLASS_LNK_FILE;
			break;
		case 's':
			newc->v.sclass = SECCLASS_SOCK_FILE;
			break;
		case '-':
			newc->v.sclass = SECCLASS_FILE;
			break;
		default:
			sprintf(errormsg, "invalid type %s", type);
			yyerror(errormsg);
			goto fail;
		}
	}
	if (parse_security_context(&newc->context[0]))
		goto fail;

	head = genfs->head;

	for (p = NULL, c = head; c; p = c, c = c->next) {
		if (!strcmp(newc->u.name, c->u.name) &&
		    (!newc->v.sclass || !c->v.sclass
		     || newc->v.sclass == c->v.sclass)) {
			sprintf(errormsg,
				"duplicate entry for genfs entry (%s, %s)",
				fstype, newc->u.name);
			yyerror(errormsg);
			goto fail;
		}
		len = strlen(newc->u.name);
		len2 = strlen(c->u.name);
		if (len > len2)
			break;
	}

	newc->next = c;
	if (p)
		p->next = newc;
	else
		genfs->head = newc;
	return 0;
      fail:
	if (type)
		free(type);
	context_destroy(&newc->context[0]);
	if (fstype)
		free(fstype);
	if (newc->u.name)
		free(newc->u.name);
	free(newc);
	return -1;
}

static int define_genfs_context(int has_type)
{
	return define_genfs_context_helper(queue_remove(id_queue), has_type);
}

static int define_range_trans(int class_specified)
{
	char *id;
	level_datum_t *levdatum = 0;
	class_datum_t *cladatum;
	range_trans_rule_t *rule;
	int l, add = 1;

	if (!mlspol) {
		yyerror("range_transition rule in non-MLS configuration");
		return -1;
	}

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		if (class_specified)
			while ((id = queue_remove(id_queue)))
				free(id);
		id = queue_remove(id_queue);
		free(id);
		for (l = 0; l < 2; l++) {
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
			id = queue_remove(id_queue);
			if (!id)
				break;
			free(id);
		}
		return 0;
	}

	rule = malloc(sizeof(struct range_trans_rule));
	if (!rule) {
		yyerror("out of memory");
		return -1;
	}
	range_trans_rule_init(rule);

	while ((id = queue_remove(id_queue))) {
		if (set_types(&rule->stypes, id, &add, 0))
			goto out;
	}
	add = 1;
	while ((id = queue_remove(id_queue))) {
		if (set_types(&rule->ttypes, id, &add, 0))
			goto out;
	}

	if (class_specified) {
		while ((id = queue_remove(id_queue))) {
			if (!is_id_in_scope(SYM_CLASSES, id)) {
				yyerror2("class %s is not within scope", id);
				free(id);
				goto out;
			}
			cladatum = hashtab_search(policydbp->p_classes.table,
			                          id);
			if (!cladatum) {
				sprintf(errormsg, "unknown class %s", id);
				yyerror(errormsg);
				goto out;
			}

			ebitmap_set_bit(&rule->tclasses, cladatum->s.value - 1,
			                TRUE);
			free(id);
		}
	} else {
		cladatum = hashtab_search(policydbp->p_classes.table,
		                          "process");
		if (!cladatum) {
			sprintf(errormsg, "could not find process class for "
			        "legacy range_transition statement\n");
			yyerror(errormsg);
			goto out;
		}

		ebitmap_set_bit(&rule->tclasses, cladatum->s.value - 1, TRUE);
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no range in range_transition definition?");
		goto out;
	}
	for (l = 0; l < 2; l++) {
		levdatum = hashtab_search(policydbp->p_levels.table, id);
		if (!levdatum) {
			sprintf(errormsg,
				"unknown level %s used in range_transition "
			        "definition", id);
			yyerror(errormsg);
			free(id);
			goto out;
		}
		free(id);

		rule->trange.level[l].sens = levdatum->level->sens;

		while ((id = queue_remove(id_queue))) {
			if (parse_semantic_categories(id, levdatum,
			                          &rule->trange.level[l].cat)) {
				free(id);
				goto out;
			}
			free(id);
		}

		id = (char *)queue_remove(id_queue);
		if (!id)
			break;
	}
	if (l == 0) {
		if (mls_semantic_level_cpy(&rule->trange.level[1],
		                           &rule->trange.level[0])) {
			yyerror("out of memory");
			goto out;
		}
	}

	append_range_trans(rule);
	return 0;

out:
	range_trans_rule_destroy(rule);
	return -1;
}


/* FLASK */


#line 4911 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

#ifdef lint
    goto yyerrlab;
#endif

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 210 "policy_parse.y"
{ if (define_policy(pass, 0) == -1) return -1; }
break;
case 4:
#line 212 "policy_parse.y"
{ if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; }
                            else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1; }}
break;
case 5:
#line 215 "policy_parse.y"
{ if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1;}}
break;
case 9:
#line 223 "policy_parse.y"
{if (define_class()) return -1;}
break;
case 12:
#line 229 "policy_parse.y"
{if (define_initial_sid()) return -1;}
break;
case 18:
#line 240 "policy_parse.y"
{if (define_common_perms()) return -1;}
break;
case 21:
#line 246 "policy_parse.y"
{if (define_av_perms(FALSE)) return -1;}
break;
case 22:
#line 248 "policy_parse.y"
{if (define_av_perms(TRUE)) return -1;}
break;
case 23:
#line 250 "policy_parse.y"
{if (define_av_perms(TRUE)) return -1;}
break;
case 29:
#line 261 "policy_parse.y"
{if (define_sens()) return -1;}
break;
case 30:
#line 263 "policy_parse.y"
{if (define_sens()) return -1;}
break;
case 32:
#line 268 "policy_parse.y"
{if (define_dominance()) return -1;}
break;
case 33:
#line 270 "policy_parse.y"
{if (define_dominance()) return -1;}
break;
case 38:
#line 279 "policy_parse.y"
{if (define_category()) return -1;}
break;
case 39:
#line 281 "policy_parse.y"
{if (define_category()) return -1;}
break;
case 42:
#line 287 "policy_parse.y"
{if (define_level()) return -1;}
break;
case 43:
#line 289 "policy_parse.y"
{if (define_level()) return -1;}
break;
case 48:
#line 298 "policy_parse.y"
{ if (define_constraint((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 49:
#line 301 "policy_parse.y"
{ if (define_validatetrans((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 69:
#line 327 "policy_parse.y"
{ if (define_attrib()) return -1;}
break;
case 70:
#line 330 "policy_parse.y"
{if (define_type(1)) return -1;}
break;
case 71:
#line 332 "policy_parse.y"
{if (define_type(0)) return -1;}
break;
case 72:
#line 335 "policy_parse.y"
{if (define_typealias()) return -1;}
break;
case 73:
#line 338 "policy_parse.y"
{if (define_typeattribute()) return -1;}
break;
case 76:
#line 344 "policy_parse.y"
{if (define_bool()) return -1;}
break;
case 77:
#line 347 "policy_parse.y"
{ if (insert_id("T",0)) return -1; }
break;
case 78:
#line 349 "policy_parse.y"
{ if (insert_id("F",0)) return -1; }
break;
case 79:
#line 352 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-4].ptr, (avrule_t*)yyvsp[-2].ptr, (avrule_t*)yyvsp[0].ptr) < 0) return -1;  }}
break;
case 80:
#line 355 "policy_parse.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 81:
#line 357 "policy_parse.y"
{ yyval.ptr = NULL; }
break;
case 82:
#line 359 "policy_parse.y"
{ yyval.ptr = yyvsp[-1].ptr;}
break;
case 83:
#line 361 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_NOT, yyvsp[0].ptr, 0);
			  if (yyval.ptr == 0) return -1; }
break;
case 84:
#line 364 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_AND, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 85:
#line 367 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_OR, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return   -1; }
break;
case 86:
#line 370 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_XOR, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 87:
#line 373 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_EQ, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 88:
#line 376 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_NEQ, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 89:
#line 379 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 90:
#line 382 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_BOOL,0, 0);
			  if (yyval.ptr == COND_ERR) return   -1; }
break;
case 91:
#line 386 "policy_parse.y"
{ yyval.ptr = define_cond_pol_list((avrule_t *)yyvsp[-1].ptr, (avrule_t *)yyvsp[0].ptr); }
break;
case 92:
#line 388 "policy_parse.y"
{ yyval.ptr = NULL; }
break;
case 93:
#line 391 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 94:
#line 393 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 95:
#line 395 "policy_parse.y"
{ yyval.ptr = NULL; }
break;
case 96:
#line 398 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVRULE_TRANSITION) ;
                          if (yyval.ptr == COND_ERR) return -1;}
break;
case 97:
#line 401 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVRULE_MEMBER) ;
                          if (yyval.ptr ==  COND_ERR) return -1;}
break;
case 98:
#line 404 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVRULE_CHANGE) ;
                          if (yyval.ptr == COND_ERR) return -1;}
break;
case 99:
#line 408 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 100:
#line 410 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 101:
#line 412 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 102:
#line 414 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 103:
#line 417 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVRULE_ALLOWED) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 104:
#line 421 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVRULE_AUDITALLOW) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 105:
#line 425 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVRULE_AUDITDENY) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 106:
#line 429 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVRULE_DONTAUDIT);
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 107:
#line 433 "policy_parse.y"
{if (define_compute_type(AVRULE_TRANSITION)) return -1;}
break;
case 108:
#line 435 "policy_parse.y"
{if (define_compute_type(AVRULE_MEMBER)) return -1;}
break;
case 109:
#line 437 "policy_parse.y"
{if (define_compute_type(AVRULE_CHANGE)) return -1;}
break;
case 110:
#line 440 "policy_parse.y"
{ if (define_range_trans(0)) return -1; }
break;
case 111:
#line 442 "policy_parse.y"
{ if (define_range_trans(1)) return -1; }
break;
case 117:
#line 451 "policy_parse.y"
{if (define_te_avtab(AVRULE_ALLOWED)) return -1; }
break;
case 118:
#line 454 "policy_parse.y"
{if (define_te_avtab(AVRULE_AUDITALLOW)) return -1; }
break;
case 119:
#line 457 "policy_parse.y"
{if (define_te_avtab(AVRULE_AUDITDENY)) return -1; }
break;
case 120:
#line 460 "policy_parse.y"
{if (define_te_avtab(AVRULE_DONTAUDIT)) return -1; }
break;
case 121:
#line 463 "policy_parse.y"
{if (define_te_avtab(AVRULE_NEVERALLOW)) return -1; }
break;
case 122:
#line 466 "policy_parse.y"
{if (define_role_types()) return -1;}
break;
case 123:
#line 468 "policy_parse.y"
{if (define_role_types()) return -1;}
break;
case 125:
#line 473 "policy_parse.y"
{if (define_role_trans()) return -1; }
break;
case 126:
#line 476 "policy_parse.y"
{if (define_role_allow()) return -1; }
break;
case 127:
#line 479 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 128:
#line 481 "policy_parse.y"
{ yyval.ptr = merge_roles_dom((role_datum_t*)yyvsp[-1].ptr, (role_datum_t*)yyvsp[0].ptr); if (yyval.ptr == 0) return -1;}
break;
case 129:
#line 484 "policy_parse.y"
{yyval.ptr = define_role_dom(NULL); if (yyval.ptr == 0) return -1;}
break;
case 130:
#line 486 "policy_parse.y"
{yyval.ptr = define_role_dom((role_datum_t*)yyvsp[-1].ptr); if (yyval.ptr == 0) return -1;}
break;
case 137:
#line 498 "policy_parse.y"
{ if (define_constraint((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 138:
#line 501 "policy_parse.y"
{ if (define_validatetrans((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 139:
#line 504 "policy_parse.y"
{ yyval.valptr = yyvsp[-1].valptr; }
break;
case 140:
#line 506 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NOT, yyvsp[0].valptr, 0);
			  if (yyval.valptr == 0) return -1; }
break;
case 141:
#line 509 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_AND, yyvsp[-2].valptr, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 142:
#line 512 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_OR, yyvsp[-2].valptr, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 143:
#line 515 "policy_parse.y"
{ yyval.valptr = yyvsp[0].valptr; }
break;
case 144:
#line 518 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_USER, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 145:
#line 521 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 146:
#line 524 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 147:
#line 526 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 148:
#line 527 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_USER, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 149:
#line 529 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 150:
#line 530 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 151:
#line 532 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 152:
#line 533 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_XTARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 153:
#line 535 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 154:
#line 536 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 155:
#line 538 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 156:
#line 539 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 157:
#line 541 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 158:
#line 542 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_XTARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 159:
#line 544 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 160:
#line 545 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 161:
#line 547 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 162:
#line 548 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 163:
#line 550 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 164:
#line 551 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_XTARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 165:
#line 554 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 166:
#line 556 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 167:
#line 557 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 168:
#line 559 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 169:
#line 560 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 170:
#line 563 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 171:
#line 565 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 172:
#line 566 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 173:
#line 568 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 174:
#line 569 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 175:
#line 572 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L1L2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 176:
#line 575 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L1H2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 177:
#line 578 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_H1L2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 178:
#line 581 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_H1H2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 179:
#line 584 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L1H1, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 180:
#line 587 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L2H2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 181:
#line 591 "policy_parse.y"
{ yyval.valptr = CEXPR_EQ; }
break;
case 182:
#line 593 "policy_parse.y"
{ yyval.valptr = CEXPR_NEQ; }
break;
case 183:
#line 596 "policy_parse.y"
{ yyval.valptr = yyvsp[0].valptr; }
break;
case 184:
#line 598 "policy_parse.y"
{ yyval.valptr = CEXPR_DOM; }
break;
case 185:
#line 600 "policy_parse.y"
{ yyval.valptr = CEXPR_DOMBY; }
break;
case 186:
#line 602 "policy_parse.y"
{ yyval.valptr = CEXPR_INCOMP; }
break;
case 189:
#line 608 "policy_parse.y"
{if (define_user()) return -1;}
break;
case 194:
#line 617 "policy_parse.y"
{if (define_initial_sid_context()) return -1;}
break;
case 199:
#line 626 "policy_parse.y"
{if (define_fs_context(yyvsp[-3].val,yyvsp[-2].val)) return -1;}
break;
case 205:
#line 637 "policy_parse.y"
{if (define_port_context(yyvsp[-1].val,yyvsp[-1].val)) return -1;}
break;
case 206:
#line 639 "policy_parse.y"
{if (define_port_context(yyvsp[-3].val,yyvsp[-1].val)) return -1;}
break;
case 211:
#line 648 "policy_parse.y"
{if (define_netif_context()) return -1;}
break;
case 216:
#line 657 "policy_parse.y"
{if (define_ipv4_node_context(yyvsp[-2].val,yyvsp[-1].val)) return -1;}
break;
case 217:
#line 659 "policy_parse.y"
{if (define_ipv6_node_context()) return -1;}
break;
case 222:
#line 668 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
break;
case 223:
#line 670 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
break;
case 224:
#line 672 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
break;
case 229:
#line 681 "policy_parse.y"
{if (define_genfs_context(1)) return -1;}
break;
case 230:
#line 682 "policy_parse.y"
{insert_id("-", 0);}
break;
case 231:
#line 683 "policy_parse.y"
{if (define_genfs_context(1)) return -1;}
break;
case 232:
#line 685 "policy_parse.y"
{if (define_genfs_context(0)) return -1;}
break;
case 233:
#line 688 "policy_parse.y"
{ 
			  unsigned int addr;
	  		  unsigned char *p = ((unsigned char *)&addr);

			  p[0] = yyvsp[-6].val & 0xff;				
			  p[1] = yyvsp[-4].val & 0xff;
			  p[2] = yyvsp[-2].val & 0xff;
			  p[3] = yyvsp[0].val & 0xff;
			  yyval.val = addr;
			}
break;
case 237:
#line 705 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 238:
#line 707 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 239:
#line 710 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 240:
#line 712 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 245:
#line 722 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 246:
#line 724 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 247:
#line 726 "policy_parse.y"
{ if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
break;
case 248:
#line 729 "policy_parse.y"
{ if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
break;
case 249:
#line 732 "policy_parse.y"
{ if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
break;
case 250:
#line 734 "policy_parse.y"
{ if (insert_id("-", 0)) return -1; }
break;
case 251:
#line 735 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 252:
#line 738 "policy_parse.y"
{ if (insert_id("~", 1)) return -1; }
break;
case 253:
#line 741 "policy_parse.y"
{ if (insert_id("*", 1)) return -1; }
break;
case 261:
#line 753 "policy_parse.y"
{ if (insert_id(yytext, 1)) return -1; }
break;
case 268:
#line 762 "policy_parse.y"
{ if (insert_id("-", 0)) return -1; }
break;
case 271:
#line 765 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 272:
#line 768 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 273:
#line 771 "policy_parse.y"
{ yyval.val = strtoul(yytext,NULL,0); }
break;
case 274:
#line 774 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 275:
#line 780 "policy_parse.y"
{ if (end_avrule_block(pass) == -1) return -1;
                          if (policydb_index_others(NULL, policydbp, 0)) return -1;
                        }
break;
case 276:
#line 785 "policy_parse.y"
{ if (define_policy(pass, 1) == -1) return -1; }
break;
case 277:
#line 788 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 292:
#line 811 "policy_parse.y"
{ if (require_class(pass)) return -1; }
break;
case 293:
#line 813 "policy_parse.y"
{ yyval.require_func = require_role; }
break;
case 294:
#line 814 "policy_parse.y"
{ yyval.require_func = require_type; }
break;
case 295:
#line 815 "policy_parse.y"
{ yyval.require_func = require_attribute; }
break;
case 296:
#line 816 "policy_parse.y"
{ yyval.require_func = require_user; }
break;
case 297:
#line 817 "policy_parse.y"
{ yyval.require_func = require_bool; }
break;
case 298:
#line 818 "policy_parse.y"
{ yyval.require_func = require_sens; }
break;
case 299:
#line 819 "policy_parse.y"
{ yyval.require_func = require_cat; }
break;
case 300:
#line 822 "policy_parse.y"
{ if (yyvsp[-1].require_func (pass)) return -1; }
break;
case 301:
#line 824 "policy_parse.y"
{ if (yyvsp[-3].require_func (pass)) return -1; }
break;
case 302:
#line 827 "policy_parse.y"
{ if (end_avrule_block(pass) == -1) return -1; }
break;
case 303:
#line 829 "policy_parse.y"
{ if (end_optional(pass) == -1) return -1; }
break;
case 304:
#line 832 "policy_parse.y"
{ if (end_avrule_block(pass) == -1) return -1; }
break;
case 306:
#line 836 "policy_parse.y"
{ if (begin_optional(pass) == -1) return -1; }
break;
case 307:
#line 839 "policy_parse.y"
{ if (begin_optional_else(pass) == -1) return -1; }
break;
#line 5850 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
